/* bhbanner.h
 *
 * Copyright (C) 2001-2004 Al Kingsley
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License as
 * published by the Free Software Foundation; either version 2 of the
 * License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * General Public License for more details.
 *
 * You should have received a copy of the GNU General Public
 * License along with this program; if not, write to the
 * Free Software Foundation, Inc., 59 Temple Place - Suite 330,
 * Boston, MA 02111-1307, USA.
 */

#ifndef BHBANNER_H
#define BHBANNER_H

#include <gtkmm/box.h>
#include <gtkmm/alignment.h>
#include <gtkmm/image.h>
#include "bhclock.h"
#include "bhdisplay.h"

namespace bhpos{

/**
 * \ingroup mflib
 * \@{	
 *
 * \defgroup bhwidget Widgets
 * \@{ 
 */
   
namespace widget{

/**
 * \@defgroup bhbanner Banner
 * \@{
 *
 * \ingroup bhwidget
 * \@{	
 */
/*! \brief A class to handle the banner.*/   
class BhBanner : public Gtk::HBox
{
public:
   BhBanner(char *);
   explicit BhBanner(BaseObjectType* cobject);
   virtual ~BhBanner();
   void SetTotal(double);

protected:
   class bhpos::widget::BhClock   *clock;
   class bhpos::widget::BhDisplay *total_disp;
   class Gtk::Image               *banner;
   class Gtk::Alignment           *calign;
   class Gtk::Alignment           *talign;
   class Gtk::Alignment           *balign;
};


/* @} 
	@} */

}

/* @} */

}

#endif // BHBANNER_H
