/*
   bhbuttontable.cpp
   Copyright (C)2004  Al Kingsley

  This program is free software; you can redistribute it and/or modify
  it under the terms of the GNU General Public License as published by
  the Free Software Foundation; either version 2 of the License, or
  (at your option) any later version.
  
	This program is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU General Public License for more details.

	You should have received a copy of the GNU General Public License
	along with this program; if not, write to the Free Software
	Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

	Part of:
	BhPos, Copyright (C) 2001-2004 Al Kingsley
	BhPos comes with ABSOLUTELY NO WARRANTY.
*/

#include "bhcombo.h"
#include <gtk/gtkcombobox.h>

namespace bhpos{

namespace widget{

BhCombo::BhCombo(BaseObjectType* cobject) : Gtk::ComboBox(cobject)
{
   ls = Gtk::ListStore::create(columns);
   set_model(ls);
   pack_start(columns.name);
}


BhCombo::~BhCombo()
{
}

void BhCombo::append_text(const Glib::ustring& text)
{
   gtk_combo_box_append_text(gobj(), text.c_str());
}

void BhCombo::insert_text(int position, const Glib::ustring& text)
{
   gtk_combo_box_insert_text(gobj(), position, text.c_str());
}

void BhCombo::prepend_text(const Glib::ustring& text)
{
   gtk_combo_box_prepend_text(gobj(), text.c_str());
}

Glib::ustring BhCombo::get_active_text() const
{
   Glib::ustring result;

   //Get the active row:
   Gtk::TreeModel::iterator active_row = get_active();
   if(active_row){
      Gtk::TreeModel::Row row = *active_row;
      result = row[columns.name];
   }

   return result;
}

void BhCombo::clear_text()
{
   ls->clear();
}

void BhCombo::set_active_text(const Glib::ustring& text)
{
   for(Gtk::TreeModel::iterator iter = ls->children().begin(); iter != ls->children().end(); ++iter){
      Glib::ustring this_text = (*iter)[columns.name];

      if(this_text == text){
         set_active(iter);
         return; //success
      }
   }

   //Not found, so mark it as blank:
   unset_active();
}

}

}
