/*
   bhcombo.h
   Copyright (C)2004  Al Kingsley

  This program is free software; you can redistribute it and/or modify
  it under the terms of the GNU General Public License as published by
  the Free Software Foundation; either version 2 of the License, or
  (at your option) any later version.
  
	This program is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU General Public License for more details.

	You should have received a copy of the GNU General Public License
	along with this program; if not, write to the Free Software
	Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

	Part of:
	BhPos, Copyright (C) 2001-2004 Al Kingsley
	BhPos comes with ABSOLUTELY NO WARRANTY.
*/

#ifndef _BHCOMBO_H
#define _BHCOMBO_H

//#include <gtkmm/comboboxtext.h>
#include <gtkmm/combobox.h>
//#include <libglademm.h>

#include <gtkmm/liststore.h>

namespace bhpos{

/**
 * @defgroup bhwidget Widgets
 * @{
 *
 * @ingroup commlib
 * @{	
 */
   
namespace widget{

/*
 * @defgroup smartbutton A not very smart button
 * @{
 *
 * @ingroup bhwidget
 * @{	
 */
/** This class should just derive from Gtk::ComboBoxText and provide a constuctor suitable for libglade's get_widget_derived() template.
 * However, I have reimplemented Gtk::ComboBoxText here temporarily, until the fixes in gtkmm 2.4.3 are widely available.
 */
class BhCombo : public Gtk::ComboBox
{
public:
   BhCombo(BaseObjectType* cobject);
   virtual ~BhCombo();

   void append_text(const Glib::ustring& text);
   void insert_text(int position, const Glib::ustring& text);
   void prepend_text(const Glib::ustring& text);
   Glib::ustring get_active_text() const;

   //This is not part of ComboBoxText:
   void clear_text();
   void set_active_text(const Glib::ustring& text);
  
protected:

   //Tree model columns:
   //These columns are used by the model that is created by the default constructor
   class BhColumns : public Gtk::TreeModel::ColumnRecord
   {
   public:
      BhColumns() { add(name); }
      Gtk::TreeModelColumn<Glib::ustring> name;
   };

   BhColumns columns;
   Glib::RefPtr<Gtk::ListStore> ls;
};

/* }@  */

}

/* }@  */

}

#endif // _BHCOMBO_H
