/*
bhitemlist.cpp
Copyright (C) 2004 Al Kingsley

  This program is free software; you can redistribute it and/or modify
  it under the terms of the GNU General Public License as published by
  the Free Software Foundation; either version 2 of the License, or
  (at your option) any later version.
  
	This program is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU General Public License for more details.

	You should have received a copy of the GNU General Public License
	along with this program; if not, write to the Free Software
	Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

	Part of:
	BhPos, Copyright (C) 2001-2005 Al Kingsley
	BhPos comes with ABSOLUTELY NO WARRANTY. 
*/
#include "config.h"
#include "bhintl.h"
#include "bhitemlist.h"
#include <gtkmm/treemodel.h>
#include <gtkmm/image.h>
#include <gtkmm/stock.h>
#include <gtkmm/label.h>
#include <gtkmm/box.h>

namespace bhpos{
   
namespace widget{


SaleColumns::SaleColumns()
{ 
   add(plu); 
   add(quantity); 
   add(description); 
   add(subtotal); 
   add(total);
   add(status);
   add(type);
   add(foreground);
   add(background);
}

SaleColours::SaleColours(Gtk::Widget *w)
{
   colormap = w->get_default_colormap();
   
   row_item_foreground.set_rgb(0, 0, 0);
   row_item_background.set_rgb(65535,65535,62913);
   row_item_foreground_sel.set_rgb(0, 0, 0);
   row_item_background_sel.set_rgb(65535,65535,62913);
   
   row_unknown_foreground.set_rgb(65535, 1024, 1024);
   //row_unknown_background.set_rgb(56000, 56000, 56000);
   
   row_unknown_foreground_sel.set_rgb(65535, 1024, 1024);
   row_item_background_sel.set_rgb(65535,65535,62913);
   
   row_lookup_foreground.set_rgb(1024, 1024, 65535);
   row_lookup_background.set_rgb(56000, 56000, 56000);
   row_return_foreground.set_rgb(0, 0, 0);
   row_return_background.set_rgb(65535, 65535, 65535);
   row_layby_foreground.set_rgb(0, 0, 0);
   row_layby_background.set_rgb(65535, 65535, 65535);
   row_rental_foreground.set_rgb(0, 0, 0);
   row_rental_background.set_rgb(65535, 65535, 65535);
   row_ephemeral_foreground.set_rgb(0, 0, 0);
   row_ephemeral_background.set_rgb(65535, 65535, 65535);
   row_priceitem_foreground.set_rgb(0, 0, 0);
   row_priceitem_background.set_rgb(65535, 65535, 65535);
   row_edit_foreground.set_rgb(65535, 65535, 65535);
   row_edit_background.set_rgb(0, 28672, 16384);
   row_editunknown_foreground.set_rgb(65535, 65535, 65535);
   row_editunknown_background.set_rgb(45056, 4096, 4096);
   row_editunknown_foreground_sel.set_rgb(65535, 65535, 65535);
   row_editunknown_background_sel.set_rgb(45056, 4096, 4096);
   
   //row_total_foreground.set_rgb(65535,65535,62913);
   row_total_foreground.set_rgb(6400, 6400, 28672);
   row_total_background.set_rgb(6400, 6400, 28672);
   
   row_tender_foreground.set_rgb(0, 0, 0);
   row_tender_background.set_rgb(32768, 32768, 60672);
   
   row_tenderedit_foreground.set_rgb(45056, 4096, 4096);
   row_tenderedit_background.set_rgb(65535,65535,62913);
   
   colormap->alloc_color(row_item_foreground);
   colormap->alloc_color(row_item_background);
   colormap->alloc_color(row_item_foreground_sel);
   colormap->alloc_color(row_item_background_sel);
   colormap->alloc_color(row_unknown_foreground);
   colormap->alloc_color(row_unknown_background);
   colormap->alloc_color(row_unknown_foreground_sel);
   colormap->alloc_color(row_unknown_background_sel);
   colormap->alloc_color(row_lookup_foreground);
   colormap->alloc_color(row_lookup_background);
   colormap->alloc_color(row_return_background);
   colormap->alloc_color(row_return_foreground);
   colormap->alloc_color(row_layby_background);
   colormap->alloc_color(row_layby_foreground);
   colormap->alloc_color(row_rental_foreground);
   colormap->alloc_color(row_rental_background);
   colormap->alloc_color(row_ephemeral_foreground);
   colormap->alloc_color(row_ephemeral_background);
   colormap->alloc_color(row_priceitem_foreground);
   colormap->alloc_color(row_priceitem_background);
   colormap->alloc_color(row_edit_background);
   colormap->alloc_color(row_edit_foreground);
   colormap->alloc_color(row_editunknown_background);
   colormap->alloc_color(row_editunknown_foreground);
   colormap->alloc_color(row_editunknown_background_sel);
   colormap->alloc_color(row_editunknown_foreground_sel);
   colormap->alloc_color(row_total_background);
   colormap->alloc_color(row_total_foreground);
   colormap->alloc_color(row_tender_background);
   colormap->alloc_color(row_tender_foreground);
   colormap->alloc_color(row_tenderedit_background);
   colormap->alloc_color(row_tenderedit_foreground);
}

void SaleColours::Set(int colour, int r, int g, int b)
{
   switch(colour){
   case BHCOL_ROW_ITEM_BACKGROUND:
      //colormap->free_colors(&row_item_foreground, 1);
      row_item_foreground.set_rgb(r, g, b);
      colormap->alloc_color(row_item_foreground);
      break;

   case BHCOL_ROW_ITEM_FOREGROUND:
      row_item_foreground.set_rgb(r, g, b);
      colormap->alloc_color(row_item_background);
      break;

   case BHCOL_ROW_ITEM_BACKGROUND_SEL:
      //colormap->free_colors(&row_item_foreground, 1);
      row_item_foreground_sel.set_rgb(r, g, b);
      colormap->alloc_color(row_item_foreground);
      break;

   case BHCOL_ROW_ITEM_FOREGROUND_SEL:
      row_item_foreground_sel.set_rgb(r, g, b);
      colormap->alloc_color(row_item_background);
      break;
   
   case BHCOL_ROW_UNKNOWN_BACKGROUND:
      row_unknown_background.set_rgb(r, g, b);
      colormap->alloc_color(row_unknown_foreground);
      break;

   case BHCOL_ROW_UNKNOWN_FOREGROUND:
      row_unknown_foreground.set_rgb(r, g, b);
      colormap->alloc_color(row_unknown_background);
      break;
   
   case BHCOL_ROW_UNKNOWN_BACKGROUND_SEL:
      row_unknown_background_sel.set_rgb(r, g, b);
      colormap->alloc_color(row_unknown_foreground);
      break;

   case BHCOL_ROW_UNKNOWN_FOREGROUND_SEL:
      row_unknown_foreground_sel.set_rgb(r, g, b);
      colormap->alloc_color(row_unknown_background);
      break;

   case BHCOL_ROW_RETURN_BACKGROUND:
      row_return_background.set_rgb(r, g, b);
      colormap->alloc_color(row_unknown_background);
      break;
   
   case BHCOL_ROW_RETURN_FOREGROUND:
      row_return_foreground.set_rgb(r, g, b);
      colormap->alloc_color(row_unknown_foreground);
      break;
   
   case BHCOL_ROW_LAYBY_BACKGROUND:
      row_layby_background.set_rgb(r, g, b);
      colormap->alloc_color(row_layby_background);
      break;

   case BHCOL_ROW_LAYBY_FOREGROUND:
      row_layby_foreground.set_rgb(r, g, b);
      colormap->alloc_color(row_layby_foreground);
      break;

   case BHCOL_ROW_RENTAL_BACKGROUND:
      row_rental_background.set_rgb(r, g, b);
      colormap->alloc_color(row_rental_background);
      break;

   case BHCOL_ROW_RENTAL_FOREGROUND:
      row_rental_foreground.set_rgb(r, g, b);
      colormap->alloc_color(row_rental_foreground);
      break;

   case BHCOL_ROW_EPHEMERAL_BACKGROUND:
      row_ephemeral_background.set_rgb(r, g, b);
      colormap->alloc_color(row_ephemeral_background);
      break;

   case BHCOL_ROW_EPHEMERAL_FOREGROUND:
      row_ephemeral_foreground.set_rgb(r, g, b);
      colormap->alloc_color(row_ephemeral_foreground);
      break;
  
    case BHCOL_ROW_PRICE_BACKGROUND:
      row_priceitem_background.set_rgb(r, g, b);
      colormap->alloc_color(row_priceitem_background);
      break;
   
   case BHCOL_ROW_PRICE_FOREGROUND:
      row_priceitem_foreground.set_rgb(r, g, b);
      colormap->alloc_color(row_priceitem_foreground);
      break;
   
   case BHCOL_ROW_EDIT_BACKGROUND:
      row_edit_background.set_rgb(r, g, b);
      colormap->alloc_color(row_edit_foreground);
      break;
   
   case BHCOL_ROW_EDIT_FOREGROUND:
      row_edit_foreground.set_rgb(r, g, b);
      colormap->alloc_color(row_edit_foreground);
      break;
   
   case BHCOL_ROW_EDITUNKNOWN_BACKGROUND:
      row_editunknown_background.set_rgb(r, g, b);
      colormap->alloc_color(row_editunknown_foreground);
      break;
   
   case BHCOL_ROW_EDITUNKNOWN_FOREGROUND:
      row_editunknown_foreground.set_rgb(r, g, b);
      colormap->alloc_color(row_editunknown_foreground);
      break;
   
   case BHCOL_ROW_EDITUNKNOWN_BACKGROUND_SEL:
      row_editunknown_background_sel.set_rgb(r, g, b);
      colormap->alloc_color(row_editunknown_foreground);
      break;
   
   case BHCOL_ROW_EDITUNKNOWN_FOREGROUND_SEL:
      row_editunknown_foreground_sel.set_rgb(r, g, b);
      colormap->alloc_color(row_editunknown_foreground);
      break;
   }
}

Gdk::Color SaleColours::Get(int colour)
{
   switch(colour){
   case BHCOL_ROW_ITEM_BACKGROUND: return row_item_background;
   case BHCOL_ROW_ITEM_FOREGROUND: return row_item_foreground;
   case BHCOL_ROW_ITEM_BACKGROUND_SEL: return row_item_background_sel;
   case BHCOL_ROW_ITEM_FOREGROUND_SEL: return row_item_foreground_sel;
   case BHCOL_ROW_UNKNOWN_BACKGROUND: return row_unknown_background;
   case BHCOL_ROW_UNKNOWN_FOREGROUND: return row_unknown_foreground;
   case BHCOL_ROW_UNKNOWN_BACKGROUND_SEL: return row_unknown_background_sel;
   case BHCOL_ROW_UNKNOWN_FOREGROUND_SEL: return row_unknown_foreground_sel;
   case BHCOL_ROW_RETURN_BACKGROUND:  return row_return_background;
   case BHCOL_ROW_RETURN_FOREGROUND: return row_return_foreground;
   case BHCOL_ROW_LAYBY_BACKGROUND: return row_layby_background;
   case BHCOL_ROW_LAYBY_FOREGROUND: return row_layby_foreground;
   case BHCOL_ROW_RENTAL_BACKGROUND: return row_rental_background;
   case BHCOL_ROW_RENTAL_FOREGROUND: return row_rental_foreground;
   case BHCOL_ROW_EPHEMERAL_BACKGROUND: return row_ephemeral_background;
   case BHCOL_ROW_PRICE_BACKGROUND: return row_priceitem_background;
   case BHCOL_ROW_PRICE_FOREGROUND: return row_priceitem_foreground;
   case BHCOL_ROW_EDIT_BACKGROUND: return row_edit_background;
   case BHCOL_ROW_EDIT_FOREGROUND: return row_edit_foreground;
   case BHCOL_ROW_EDITUNKNOWN_BACKGROUND: return row_editunknown_background;
   case BHCOL_ROW_EDITUNKNOWN_FOREGROUND: return row_editunknown_foreground;
   case BHCOL_ROW_EDITUNKNOWN_BACKGROUND_SEL: return row_editunknown_background_sel;
   case BHCOL_ROW_EDITUNKNOWN_FOREGROUND_SEL: return row_editunknown_foreground_sel;
   case BHCOL_ROW_TOTAL_BACKGROUND: return row_total_background;
   case BHCOL_ROW_TOTAL_FOREGROUND: return row_total_foreground;
   case BHCOL_ROW_TENDER_BACKGROUND: return row_tender_background;
   case BHCOL_ROW_TENDER_FOREGROUND: return row_tender_foreground;
   case BHCOL_ROW_TENDEREDIT_BACKGROUND: return row_tenderedit_background;
   case BHCOL_ROW_TENDEREDIT_FOREGROUND: return row_tenderedit_foreground;
   }
}

BhItemList::BhItemList(Gtk::ScrolledWindow *sw) : Gtk::TreeView()
{  
   curr_column=0;
   Glib::ustring buff;
   bDropNext=false;
   bShortList=false;
   mode=BHITEMLIST_MODE_IDLE;
   set_name("bhitemlist");
   
   i_curr_row=0;
   row_height=0;
   num_rows=0;
   
   colours=new SaleColours(this);
   
   refls = Gtk::TreeStore::create(columns);
   set_model(refls);
   refSelection = get_selection();
   
   //Gtk::TreeViewColumn *column = Gtk::manage(new class Gtk::TreeViewColumn("PLU"));
   Gtk::TreeViewColumn *col0_validated = new class Gtk::TreeViewColumn("PLU");
   //col0_validated->set_spacing(0);
   //cell_col0 = new BhCellRendererText();
   cell_col0 = Gtk::manage(new Gtk::CellRendererText());
   col0_validated->pack_start(*manage(cell_col0));
   col0_validated->add_attribute(cell_col0->property_text(), columns.plu);
   col0_validated->add_attribute(cell_col0->property_background_gdk(), columns.background);
   col0_validated->add_attribute(cell_col0->property_foreground_gdk(), columns.foreground);
   cell_col0->property_background_set()=true;
   cell_col0->property_foreground_set()=true;
   //col0_validated->set_cell_data_func(*cell_col0, sigc::mem_fun(*this, &BhItemList::on_col0_validate));
   append_column(*manage(col0_validated));
   cell_col0->property_editable()=true;
   cell_col0->signal_edited().connect(sigc::mem_fun(*this, &BhItemList::on_col0_changed));
   //cell_col0->stop_editing().connect(sigc::mem_fun(*this, &BhItemList::on_col0_changed));
   cell_col0->signal_editing_started().connect(sigc::mem_fun(*this, &BhItemList::cell0_editstarted));
   cell_col0->signal_editing_canceled().connect(sigc::mem_fun(*this, &BhItemList::cell0_editcancelled));
   
   Gtk::TreeViewColumn *column1 = Gtk::manage(new class Gtk::TreeViewColumn("Qty"));
   //column1->set_spacing(0);
   append_column(*column1);
   cell_col1 = Gtk::manage(new Gtk::CellRendererText());
   column1->pack_start(*manage(cell_col1));
   column1->add_attribute(cell_col1->property_text(), columns.quantity);
   column1->add_attribute(cell_col1->property_background_gdk(), columns.background);
   column1->add_attribute(cell_col1->property_foreground_gdk(), columns.foreground);
   cell_col1->property_background_set()=true;
   cell_col1->property_foreground_set()=true;
   cell_col1->signal_edited().connect(sigc::mem_fun(*this, &BhItemList::on_col1_changed));
   cell_col1->signal_editing_canceled().connect(sigc::mem_fun(*this, &BhItemList::cell1_editcancelled));
   
   Gtk::TreeViewColumn *column2 = Gtk::manage(new class Gtk::TreeViewColumn("Description"));
   //column2->set_spacing(0);
   append_column(*column2);
   cell_col2 = Gtk::manage(new Gtk::CellRendererText());
   column2->pack_start(*manage(cell_col2));
   column2->add_attribute(cell_col2->property_text(), columns.description);
   column2->add_attribute(cell_col2->property_background_gdk(), columns.background);
   column2->add_attribute(cell_col2->property_foreground_gdk(), columns.foreground);
   cell_col2->property_background_set()=true;
   cell_col2->property_foreground_set()=true;
   cell_col2->signal_edited().connect(sigc::mem_fun(*this, &BhItemList::on_col0_changed));
   cell_col2->signal_editing_canceled().connect(sigc::mem_fun(*this, &BhItemList::cell2_editcancelled));
   
   Gtk::TreeViewColumn *column3 = Gtk::manage(new class Gtk::TreeViewColumn("Price"));
   //column3->set_spacing(0);
   append_column(*column3);
   cell_col3 = Gtk::manage(new Gtk::CellRendererText());
   column3->pack_start(*manage(cell_col3));
   column3->add_attribute(cell_col3->property_text(), columns.subtotal);
   column3->add_attribute(cell_col3->property_background_gdk(), columns.background);
   column3->add_attribute(cell_col3->property_foreground_gdk(), columns.foreground);
   cell_col3->property_background_set()=true;
   cell_col3->property_foreground_set()=true;
   cell_col3->signal_edited().connect(sigc::mem_fun(*this, &BhItemList::on_col3_changed));
   cell_col3->signal_editing_canceled().connect(sigc::mem_fun(*this, &BhItemList::cell3_editcancelled));
   
   Gtk::TreeViewColumn *column4 = Gtk::manage(new class Gtk::TreeViewColumn("Total"));
   //column4->set_spacing(0);
   append_column(*column4);
   cell_col4 = Gtk::manage(new Gtk::CellRendererText());
   column4->pack_start(*manage(cell_col4));
   column4->add_attribute(cell_col4->property_text(), columns.total);
   column4->add_attribute(cell_col4->property_background_gdk(), columns.background);
   column4->add_attribute(cell_col4->property_foreground_gdk(), columns.foreground);
   cell_col4->property_background_set()=true;
   cell_col4->property_foreground_set()=true;
   cell_col4->signal_edited().connect(sigc::mem_fun(*this, &BhItemList::on_col0_changed));
   
   get_column(0)->set_sizing(Gtk::TREE_VIEW_COLUMN_FIXED);
   get_column(0)->set_fixed_width(120);
   get_column(1)->set_sizing(Gtk::TREE_VIEW_COLUMN_FIXED);
   get_column(1)->set_fixed_width(40);
   get_column(2)->set_sizing(Gtk::TREE_VIEW_COLUMN_FIXED);
   get_column(2)->set_fixed_width(380);
   get_column(3)->set_sizing(Gtk::TREE_VIEW_COLUMN_FIXED);
   get_column(3)->set_fixed_width(50);
   get_column(4)->set_sizing(Gtk::TREE_VIEW_COLUMN_FIXED);
   get_column(4)->set_fixed_width(50);
   
   set_flags(Gtk::CAN_FOCUS);
   set_headers_visible(true);
   set_rules_hint(false);
   set_reorderable(false);
   set_enable_search(true);

   {
      Gtk::Menu::MenuList& menulist = item_popup.items();

      menulist.push_back(Gtk::Menu_Helpers::MenuElem("_Edit", sigc::mem_fun(*this, &BhItemList::on_sale_popup)));
      menulist.push_back(Gtk::Menu_Helpers::MenuElem("_Process", sigc::mem_fun(*this, &BhItemList::on_sale_popup)));
      menulist.push_back(Gtk::Menu_Helpers::MenuElem("_Remove", sigc::mem_fun(*this, &BhItemList::on_sale_popup)));
   }
   item_popup.accelerate(*this);
   
   {
      Gtk::Menu::MenuList& menulist = pay_popup.items();

      menulist.push_back(Gtk::Menu_Helpers::MenuElem(_("_Cash"), sigc::mem_fun(*this, &BhItemList::on_pay_popup)));
      menulist.push_back(Gtk::Menu_Helpers::MenuElem(_("_Cheque"), sigc::mem_fun(*this, &BhItemList::on_pay_popup)));
      menulist.push_back(Gtk::Menu_Helpers::MenuElem(_("_Credit"), sigc::mem_fun(*this, &BhItemList::on_pay_popup)));
      menulist.push_back(Gtk::Menu_Helpers::MenuElem(_("_Other"), sigc::mem_fun(*this, &BhItemList::on_pay_popup)));
   }
   pay_popup.accelerate(*this);
   
   scroll_win=sw;
   row_height = (int) scroll_win->get_vadjustment()->get_upper();
   
   //refSelection->set_select_function(sigc::mem_fun(*this, &BhItemList::select_function));
   //refSelection->signal_changed().connect(sigc::mem_fun(*this, &BhItemList::on_selection_changed));
}

BhItemList::~BhItemList()
{  
}

/****
 *
 * Row selection is based on the status
 *
 *
 */
/*
bool BhItemList::select_function(const Glib::RefPtr<Gtk::TreeModel>& model, const Gtk::TreeModel::Path& path, bool bCurr)
{
   Gtk::TreeModel::iterator iter = model->get_iter(path);
   Gtk::TreeModel::Row      row=*iter;

   if(row[columns.status]==BHITEMLIST_STATUS_FIXED) return false;
   
   return true;
   //return iter->children().empty(); // only allow leaf nodes to be selected
}
*/

void BhItemList::on_sale_popup()
{
   Glib::RefPtr<Gtk::TreeView::Selection> refSelection = get_selection();
   if(refSelection){
      Gtk::TreeModel::iterator iter = refSelection->get_selected();
      if(iter){
         //int qty = (*iter)[columns.qty];
         //std::cout << "  Selected qty=" << qty << std::endl;
      }
   }
}

void BhItemList::on_pay_popup()
{
   Glib::RefPtr<Gtk::TreeView::Selection> refSelection = get_selection();
   if(refSelection){
      Gtk::TreeModel::iterator iter = refSelection->get_selected();
      if(iter){
         //int qty = (*iter)[columns.qty];
         //std::cout << "  Selected qty=" << qty << std::endl;
      }
   }
}

void BhItemList::cell0_editcancelled()
{
   completion_signal.emit(BHITEMLIST_COMPLETION_PLUCANCELLED, NULL, NULL);
}

void BhItemList::cell1_editcancelled()
{
   completion_signal.emit(BHITEMLIST_COMPLETION_QTYCANCELLED, NULL, NULL);
}

void BhItemList::cell2_editcancelled()
{
   completion_signal.emit(BHITEMLIST_COMPLETION_DESCEDITCANCELLED, NULL, NULL);
}

void BhItemList::cell3_editcancelled()
{
   completion_signal.emit(BHITEMLIST_COMPLETION_PRICEEDITCANCELLED, NULL, NULL);
}

void BhItemList::on_col0_validate(Gtk::CellRenderer* cell, const Gtk::TreeModel::iterator& iter)
{
   Glib::ustring valid="01234567890";
   Gtk::CellRendererText& renderer = dynamic_cast<Gtk::CellRendererText&>(*cell);
   Glib::ustring new_text=renderer.property_text();
   //Get the value from the model and show it appropriately in the view:
   if(iter){
      Gtk::TreeModel::Row row = *iter;
      if(new_text.find_first_not_of(valid)==std::string::npos){
         //g_print("on_col0_validate - %s - ", new_text.data());
         row[columns.plu]=new_text;
      }
      else{
         //Glib::ustring::iterator i=new_text.end();
         //new_text.erase(i);
         //set_cursor(path, m_treeviewcolumn_validated, m_cellrenderer_validated, true);
         //return;
      }
   }
}

void BhItemList::cell0_editstarted(Gtk::CellEditable* cell_editable, const Glib::ustring& path)
{
   if(!cell_editable){
      g_print("noneditable!\n");
   }
   
   Gtk::CellEditable* celleditable_validated = cell_editable;
   Gtk::Entry *pEntry = dynamic_cast<Gtk::Entry*>(cell_editable);
     
   if(!pEntry){
      g_print("no cell\n");
      return;
   }
   
   if(pEntry){
      bHaveRow=false;
      Gtk::Editable *pEditable = dynamic_cast<Gtk::Editable*>(pEntry);
      
      int l=pEntry->get_text_length();
      //pEntry->select_region(0, 0);
      //pEntry->set_position(l);
      //Glib::ustring t=pEntry->get_chars(0,1);
      //pEntry->delete_selection();
      //pEntry->set_text(t);
      //pEditable->select_region(0, 0);
      //pEditable->set_position(-1);
         
      bCell0Retry = false;
      cell0_oldtext.clear();
   }
}

// when return is pressed, i.e. editing finished
void BhItemList::on_col0_changed(const Glib::ustring& path, const Glib::ustring& new_text)
{
   Glib::ustring valid="01234567890abcdefghijklmnopqrstuvwxyzABCDEFGHIJKLMNOPQRSTUVWXYZ";
   Glib::ustring q;
   refSelection=get_selection();
   Gtk::TreeModel::iterator iter = refSelection->get_selected();
   Gtk::TreeModel::Row  row=*iter;
   Gtk::TreeModel::Path pathos(path);
   /*
   Gtk::TreePath path(path_string);

   //Convert the inputed text to an integer, as needed by our model column:
   char* pchEnd = 0;
   int new_value = strtol(new_text.c_str(), &pchEnd, 10);

   if(new_value > 10){
      //Prevent entry of numbers higher than 10.
   
      //Start editing again, with the bad text, so that the user can correct it.
      //A real application should probably allow the user to revert to the previous text.
    
      //Set the text to be used in the start_editing signal handler:
      cell0_oldtext = new_text;
      m_validate_retry = true;

      //Start editing again:
      set_cursor(path, m_treeviewcolumn_validated, m_cellrenderer_validated, true);
   }
   else{
      //Get the row from the path:
      Gtk::TreeModel::iterator iter = m_refTreeModel->get_iter(path);
      if(iter){
         Gtk::TreeModel::Row row = *iter;
         //Put the new value in the model:
         row[m_Columns.m_col_number_validated] = new_value;
      }
   }
   */
   if(bHaveRow){
      row = *curr_row;
      bHaveRow=false;
   }
   
   switch(row[columns.status]){
   case BHITEMLIST_STATUS_PLUSCAN:
      //g_print("scanitem\n");
      return;
   
   case BHITEMLIST_STATUS_PLUEDIT:
   {
      if(new_text.find_first_not_of(valid)==std::string::npos){
         row[columns.plu]=new_text;
      }
      else{
         //Glib::ustring::iterator i=new_text.end();
         //new_text.erase(i);
         bCell0Retry = true;
         cell0_oldtext=new_text;
         set_cursor(pathos, col0_validated, *cell_col0, true);
         //return;
      }
      //row[columns.plu] = new_text;
   }
      //return;
      break;
   
   case BHITEMLIST_STATUS_QTYEDIT:
      row[columns.status]=BHITEMLIST_STATUS_PLUEDIT;
      row[columns.quantity] = new_text;
      cell_col0->property_editable()=true;
      cell_col1->property_editable()=false;
      grab_focus();
      set_cursor(pathos, *get_column(0), true);
      return;
   
   case BHITEMLIST_STATUS_DESCEDIT:
      row[columns.status]=BHITEMLIST_STATUS_PRICEEDIT;
      row[columns.description] = new_text;
      cell_col3->property_editable()=true;
      cell_col2->property_editable()=false;
      grab_focus();
      set_cursor(pathos, *get_column(3), true);
      //completion_signal.emit(BHITEMLIST_COMPLETION_DESCEDIT, NULL);
      return;
   
   case BHITEMLIST_STATUS_PRICEEDIT:
      row[columns.status]=BHITEMLIST_STATUS_FIXED;
      row[columns.description] = new_text;
      cell_col3->property_editable()=true;
      cell_col2->property_editable()=false;
      //grab_focus();
      //set_cursor(pathos, *get_column(3), true);
   /*
      bhpos::CSaleItem si;
      si.SetPLU();
      si.SetQuantity();
      si.SetDescription();
      si.SetRecText();
      si.SetPrice();
      completion_signal.emit(BHITEMLIST_COMPLETION_PRICEEDIT, &si);*/
      return;
   /*
   case BHITEMLIST_STATUS_AMOUNTEDIT:
   {
      q=row[columns.subtotal];
      double a=strtof(q.c_str(), NULL);
      due-=a;
      if(due>0.0){
      }
      else if(due < 0.0){
      }
      else{ // == 0.0
      }
      row[columns.status]=BHITEMLIST_STATUS_PAYFIXED;
      completion_signal.emit(BHITEMLIST_COMPLETION_PAYAMOUNT, &a);
      cell_col3->property_editable()=false;
   }*/
      return;
   }
   
   //g_print("col0_change 1 - %s\n", new_text.data());
   row[columns.plu] = new_text;
   if(row[columns.quantity] == ""){
      row[columns.quantity] = "1";
   }
   
   q=row[columns.quantity];
   int z=atoi(q.c_str());
   q=row[columns.plu];
   cell_col0->property_editable()=false;
   cell_col1->property_editable()=false;
   pluentry_signal.emit(z, q);
}

void BhItemList::on_col1_changed(const Glib::ustring& path, const Glib::ustring& new_text)
{
   int           i;
   Glib::ustring valid="01234567890";
   refSelection=get_selection();
   Gtk::TreeModel::iterator iter = refSelection->get_selected();
   Gtk::TreeModel::Row  row=*iter;
   Gtk::TreeModel::Path pathos(path);

   if(row[columns.status] == BHITEMLIST_STATUS_QTYEDIT){
      if(new_text.find_first_not_of(valid)==std::string::npos){
         row[columns.quantity]=new_text;
      }
   }
   else{
      row[columns.status]=BHITEMLIST_STATUS_QTYEDIT;
      if(new_text.find_first_not_of(valid)==std::string::npos){
         row[columns.quantity]=new_text;
      }
   }
   //g_print("cell1 changed\n");
   cell_col0->property_editable()=true;
   cell_col1->property_editable()=false;
   row[columns.status]=BHITEMLIST_STATUS_ADD;
   set_cursor(pathos, *get_column(0), true);
   completion_signal.emit(BHITEMLIST_COMPLETION_QTY, &i, NULL);
}
/*
void BhItemList::on_col2_changed(const Glib::ustring& path, const Glib::ustring& new_text)
{
   refSelection=get_selection();
   Gtk::TreeModel::iterator iter = refSelection->get_selected();
   Gtk::TreeModel::Row  row=*iter;
   
   row[columns.description] = new_text;
}
*/
void BhItemList::on_col3_changed(const Glib::ustring& path, const Glib::ustring& new_text)
{
   int           i;
   double        a;
   char          buff[32];
   bhpos::CSaleItem si;
   Glib::ustring valid="01234567890.";
   refSelection=get_selection();
   Gtk::TreeModel::iterator iter = refSelection->get_selected();
   if(!iter){
      g_print("bollocks\n");
   }
   Gtk::TreeModel::Row  row=*iter;


   //g_print("cell3 returned:%d\n", row[columns.status]);
   a=atof(new_text.c_str());
   sprintf(buff,"%0.2f", a);
   
   if(row[columns.status] == BHITEMLIST_STATUS_AMOUNTEDIT){
      if(new_text.find_first_not_of(valid)==std::string::npos){
         row[columns.subtotal]=buff;
      }
      else{
         row[columns.subtotal]="";
         Gtk::TreeModel::Path pathos(path);
         set_cursor(pathos, *get_column(3), true);
         return;
      }
   }
   else if(row[columns.status] == BHITEMLIST_STATUS_CASHITEM){
      row[columns.subtotal]=buff;
      a=atof(new_text.c_str());
      cell_col3->property_editable()=false;
      row[columns.status]=BHITEMLIST_STATUS_FIXED;
      row[columns.type]=BHITEMLIST_TYPE_PRICE;
      if(bTaxInclusive){
         a=a*si.GetQuantity();
         sprintf(buff, "%0.2f", (a + (a * si.GetTax())));
         row[columns.total] = buff;
      }
      else{
	      a=a*si.GetQuantity();
         sprintf(buff, "%0.2f", a);
         row[columns.total]=buff;
	   }
      refSelection->unselect_all();
      completion_signal.emit(BHITEMLIST_COMPLETION_CASHITEM, &a, NULL);
      SetRowColour(row);
      return;
   }
   else if(row[columns.status] == BHITEMLIST_STATUS_PRICEEDIT){
      row[columns.subtotal]=buff;
      a=atof(new_text.c_str());
      
      si.SetPLU("-------------");
      valid=row[columns.quantity];
      int z=atoi(valid.c_str());
      si.SetQuantity(z);
      si.SetDispText(row[columns.description]);
      si.SetRecText("Cash Item");
      si.SetPrice(a);
      cell_col3->property_editable()=false;
      if(bTaxInclusive){
         a=a*si.GetQuantity();
         //g_print("bhitemlist tax inclu qty/total: %d %0.2f %f", saleitem->GetQuantity(), price, saleitem->GetTax());
         sprintf(buff, "%0.2f", (a + (a * si.GetTax())));
         row[columns.total] = buff;
      }
      else{
	      a=a*si.GetQuantity();
         //g_print("bhitemlist tax ninclu qty/total: %d %0.2f\n", saleitem->GetQuantity(), price);
         sprintf(buff, "%0.2f", a);
         row[columns.total]=buff;
	   }
      row[columns.status]=BHITEMLIST_STATUS_FIXED;
      row[columns.type]=BHITEMLIST_TYPE_UNKNOWN;
      refSelection->unselect_all();
      SetRowColour(row);
      completion_signal.emit(BHITEMLIST_COMPLETION_PRICEEDIT, &si, NULL);
      return;
   }
   else{
      row[columns.status]=BHITEMLIST_STATUS_AMOUNTEDIT;
      if(new_text.find_first_not_of(valid)==std::string::npos){
         row[columns.subtotal]=buff;
      }
   }
   
   //g_print("cell3 changed\n");
   cell_col3->property_editable()=false;
   
   if(new_text==""){ // balance...
      row[columns.status]=BHITEMLIST_STATUS_PAYFIXED;
      sprintf(buff,"%0.2f", due);
      row[columns.subtotal]=buff;
      curr_payitem.SetAmount(due);
      completion_signal.emit(BHITEMLIST_COMPLETION_PAYBALANCE, &curr_payitem, NULL);
      total_row[columns.subtotal]="0.00";
      return;   
   }
   
   a=atof(new_text.c_str());
   due-=a;
   curr_payitem.SetAmount(a);
   if(due > 0.0){
      sprintf(buff,"%0.2f", due);
      total_row[columns.subtotal]=buff;
      SetRowColour(total_row);
      row[columns.status]=BHITEMLIST_STATUS_PAYFIXED;
      completion_signal.emit(BHITEMLIST_COMPLETION_PAYAMOUNTMORE, &curr_payitem, NULL);
      return;
   }
   else if(due < 0.0){
      // only with cash
      if(curr_payitem.GetID()==PTYPE_CASH){
         total_row[columns.subtotal]="0.00";
         completion_signal.emit(BHITEMLIST_COMPLETION_PAYCHANGE, &curr_payitem, NULL);
         SetRowColour(total_row);
         row[columns.status]=BHITEMLIST_STATUS_PAYFIXED;
         
         row = *(refls->append());
         row[columns.status]=BHITEMLIST_STATUS_PAYFIXED;
         due=-due;
         sprintf(buff,"%0.2f", due);
         row[columns.subtotal]=buff;
         row[columns.description]="Change";
         SetRowColour(row);
         return;
      }
      else{ // unless cashback - emit an error
         completion_signal.emit(BHITEMLIST_COMPLETION_PAYERROR, &curr_payitem, NULL);
      }
   }
   else if(due == 0.0){
      total_row[columns.subtotal]="0.00";
   }
   SetRowColour(total_row);
   row[columns.status]=BHITEMLIST_STATUS_PAYFIXED;
   completion_signal.emit(BHITEMLIST_COMPLETION_PAYAMOUNT, &curr_payitem, NULL);
   cell_col3->property_editable()=false;
}
/*
void BhItemList::on_col4_changed(const Glib::ustring& path, const Glib::ustring& new_text)
{
   refSelection=get_selection();
   Gtk::TreeModel::iterator iter = refSelection->get_selected();
   Gtk::TreeModel::Row  row=*iter;
   
   row[columns.total] = new_text;
}
*/
void BhItemList::SetSelection(bool bMultiple)
{
   Glib::RefPtr<Gtk::TreeSelection> refTreeSelection = get_selection();
   if(bMultiple)
      refTreeSelection->set_mode(Gtk::SELECTION_MULTIPLE);
   else
      refTreeSelection->set_mode(Gtk::SELECTION_SINGLE);
}

void BhItemList::Select(int n)
{
   Gtk::TreeModel::Row row = refls->children()[n]; 
   if(row)
      refSelection->select(row);
}

bool BhItemList::fillitem(CSaleItem *si)
{
   refSelection=get_selection();
   Gtk::TreeModel::iterator iter = refSelection->get_selected();
   Gtk::TreeModel::Row  row;
   Glib::ustring        buff;
   
   if(iter){
      row=*iter;
      buff=row[columns.plu];
      si->SetPLU(buff.data());
      buff=row[columns.quantity];
      if(buff==""){
         si->SetQuantity(1);
      }
      else{
         si->SetQuantity(atoi(buff.data()));
      }
   }
}

bool BhItemList::IsValidPath(Gtk::TreeModel::Path path)
{
   return false;
}

int BhItemList::Update(CTransItems& transaction)
{
   BhItemListMode ret=BHITEMLIST_MODE_IDLE;
   CSaleItem si;
	CPayItem  pi;
   int       i;
   
   Clear();
   
   if(transaction.NumAllItems()==0) return 1;

   g_print("update: num items: %d\n", transaction.NumAllItems());
   
   for(i=0; i < transaction.NumAllItems(); i++){
		if(transaction.GetItem(i, si)){
         g_print("update::trans - item not found\n");
		}
		else{
     		Append(&si);
  		}
	}
   /*
   if(BHCLIST_MODE_TENDERTYPE){
      SetMode(BHCLIST_MODE_TENDERTYPE);
   }
   if(transaction.GetStatus()==BhPos::BHTRANS_STATUS_TENDER){
      SetMode(BHCLIST_MODE_TENDERTYPE);
   }
   if(transaction.NumPayment() > 0){
	   for(i=1; i < transaction.NumPayment(); i++){
		   if(transaction.GetPayItem(i, pi)){
            //g_print("update::trans - item not found\n");
		   }
		   else{
     	      AddPayType(pi.GetID());
            Add(pi);
            //ret=BHCLIST_STATE_APAY;
	      }
      }
	}
   */
	return ret;
}

int BhItemList::SaleMode(CTransItems& transaction)
{
   refls->clear();
   
   get_column(0)->set_title(_("PLU"));
   get_column(1)->set_title(_("Qty"));
   get_column(2)->set_title(_("Description"));
   get_column(3)->set_title(_("Price"));
   get_column(4)->set_title(_("Sub"));
   
	return Update(transaction);
}

int BhItemList::PayMode(double amount, bool bShow)
{
   total=amount;
   char                 cbuff[32];
   Glib::ustring        buff;
   Gtk::TreeModel::Row  row;
   Gtk::TreeModel::Path path;
   Gtk::TreeModel::iterator iter;
   
   if(bShow){
      curr_row=refls->append();
      row = *curr_row;
      row[columns.type]=BHITEMLIST_TYPE_BLANK;
      curr_row=refls->append();
      total_row=row= *curr_row;
      buff=_("Amount Due : ");
      row[columns.description]=buff;
      sprintf(cbuff, "%0.2f", amount);
      buff=cbuff;
      row[columns.subtotal]=buff;
      row[columns.type]=BHITEMLIST_TYPE_TOTAL;
      row[columns.status]=BHITEMLIST_STATUS_PAYFIXED;
      refSelection->unselect_all();
      mode=BHITEMLIST_MODE_TENDERTYPE;
      SetRowColour(row);
      refSelection->select(row);
   }
   else{
      // remove to curr_row, remove two more rows...
      path=curr_row;
      iter=refls->get_iter(path);
      if(*iter==total_row){
         refls->erase(*iter);
         path.prev();
         iter=refls->get_iter(path);
         refls->erase(*iter);
         return 0;
      }
      while(*iter!=total_row){
         refls->erase(*iter);
         path.prev();
         iter=refls->get_iter(path);
      }
      refSelection->unselect_all();
   }
   return 0;
}

void BhItemList::SetRowColour(Gtk::TreeModel::iterator iter)
{
   Gdk::Color  fg, bg;
   
   if(!iter) return;
   Gtk::TreeModel::Row row=*iter;
   SetRowColour(row);
   //return;
}

void BhItemList::SetRowColour(Gtk::TreeModel::Row& row)
{
   Gdk::Color  fg, bg;
   
   if(!row) return;
   
   //return;
   
   if(row[columns.status] == BHITEMLIST_STATUS_PAYFIXED){
      switch(row[columns.type]){
      case BHITEMLIST_TYPE_TOTAL:
         fg = colours->Get(BHCOL_ROW_TOTAL_FOREGROUND);
         bg = colours->Get(BHCOL_ROW_TOTAL_BACKGROUND);
         break;
         
      case BHITEMLIST_TYPE_TENDERTYPE_CASH:
         fg = colours->Get(BHCOL_ROW_TENDER_FOREGROUND);
         bg = colours->Get(BHCOL_ROW_TENDER_BACKGROUND);
         break;
      }
   }
   else if(row[columns.status] == BHITEMLIST_STATUS_FIXED){
      switch(row[columns.type]){
      case BHITEMLIST_TYPE_BLANK:
         break;
      case BHITEMLIST_TYPE_ITEM:
         fg=colours->Get(BHCOL_ROW_ITEM_FOREGROUND);
         bg=colours->Get(BHCOL_ROW_ITEM_BACKGROUND);
         break;
      
      case BHITEMLIST_TYPE_UNKNOWN:
         fg=colours->Get(BHCOL_ROW_UNKNOWN_FOREGROUND);
         bg=colours->Get(BHCOL_ROW_UNKNOWN_BACKGROUND);
         break;
      
      case BHITEMLIST_TYPE_LOOKUP:
         fg=colours->Get(BHCOL_ROW_LOOKUP_FOREGROUND);
         bg=colours->Get(BHCOL_ROW_LOOKUP_BACKGROUND);
         break;

      case BHITEMLIST_TYPE_PRICE:
         fg=colours->Get(BHCOL_ROW_PRICE_FOREGROUND);
         bg=colours->Get(BHCOL_ROW_PRICE_BACKGROUND);
         break;
      
      case BHITEMLIST_TYPE_RETURN:
      case BHITEMLIST_TYPE_LAYBY:
      case BHITEMLIST_TYPE_RENTAL:
      case BHITEMLIST_TYPE_EPHEMERAL:
         break;
      default:
         return;
      }
   }
   else if(row[columns.status] == BHITEMLIST_STATUS_DESCEDIT){
      fg=colours->Get(BHCOL_ROW_EDITUNKNOWN_FOREGROUND);
      bg=colours->Get(BHCOL_ROW_EDITUNKNOWN_BACKGROUND);
   }
   else if(row[columns.status] == BHITEMLIST_STATUS_PRICEEDIT){
      fg=colours->Get(BHCOL_ROW_EDITUNKNOWN_FOREGROUND);
      bg=colours->Get(BHCOL_ROW_EDITUNKNOWN_BACKGROUND);
   }
   else if(row[columns.status]==BHITEMLIST_STATUS_AMOUNTEDIT){
      fg=colours->Get(BHCOL_ROW_TENDER_FOREGROUND);
      bg=colours->Get(BHCOL_ROW_TENDER_BACKGROUND);
   }
   
   row[columns.foreground]=fg;
   //row[columns.background]=bg;
   
   return;
}

/*
int BhItemList::TransSummary(bool, BhServiceTransSum *ts)
{
   refls->clear();
   
   get_column(0)->set_title(_(""));   
   get_column(1)->set_title(_(""));
   get_column(2)->set_title(_("Description"));
   get_column(3)->set_title(_("Num"));
   get_column(4)->set_title(_("Amount"));

   return 0;
}

int BhItemList::UserSummary(bool, BhServiceUserSum *us)
{
   refls->clear();
   
   get_column(0)->set_title(_("User"));   
   get_column(1)->set_title(_("Li"));
   get_column(2)->set_title(_("Description"));
   get_column(3)->set_title(_("Num"));
   get_column(4)->set_title(_("Amount"));
   
   return 0;
}

int BhItemList::CashDrawerAdjust(CCash& cashd, bool bShow)
{
   refls->clear();
   
   get_column(0)->set_title(_("Unit"));   
   get_column(1)->set_title(_("Qty"));
   get_column(2)->set_title(_("Operation"));
   get_column(3)->set_title(_("To"));
   get_column(4)->set_title(_("Sub"));
   
   return 0;
}

int BhItemList::EphemeralsIn(bool bShow)
{
   get_column(0)->set_title(_("PLU"));   
   get_column(1)->set_title(_("S"));
   get_column(2)->set_title(_("Prescription Number"));
   get_column(3)->set_title(_("Price"));
   get_column(4)->set_title(_("Bin"));
   return 0;
}

int BhItemList::Ephemerals(CTransItems&, CTransItems&, bool bShow)
{
   refls->clear();
   
   get_column(0)->set_title(_("PLU"));   
   get_column(1)->set_title(_("When"));
   get_column(2)->set_title(_("Description"));
   get_column(3)->set_title(_("Price"));
   get_column(4)->set_title(_("Sold"));
   
   return 0;
}

int BhItemList::CustomerList(BhCustomerList *cl, bool bShow)
{
   
   
   get_column(0)->set_title(_("Last Name"));   
   get_column(1)->set_title(_("I."));
   get_column(2)->set_title(_("Details"));
   get_column(3)->set_title(_("Zip"));
   get_column(4)->set_title(_("ID"));
   
   return 0;
}

int BhItemList::CustomerSelection(char *)
{
   return 0;
}

int BhItemList::DeliveryList(BhDeliveryList *, bool bShow)
{
   refls->clear();
   
   get_column(0)->set_title(_("Name"));   
   get_column(1)->set_title(_("I"));
   get_column(2)->set_title(_("Address"));
   get_column(3)->set_title(_("Total"));
   get_column(4)->set_title(_("ID"));
   
   return 0;
}

int BhItemList::DeliverySummary(BhDeliveryList *dl, bool bShow)
{
   refls->clear();
   
   get_column(0)->set_title(_("Name"));   
   get_column(1)->set_title(_("I"));
   get_column(2)->set_title(_("Address"));
   get_column(3)->set_title(_("Who"));
   get_column(4)->set_title(_("Status"));
   
   return 0;
}

int BhItemList::DeliveryReturnList(BhDeliveryReturnList *, bool bShow)
{
   refls->clear();
   
   get_column(0)->set_title(_("Name"));   
   get_column(1)->set_title(_("I"));
   get_column(2)->set_title(_("Address"));
   get_column(3)->set_title(_("Status"));
   get_column(4)->set_title(_("Amoun"));
   
   return 0;
}

int BhItemList::DeliveryPay(BhDeliveryReturnList *, bool bShow)
{
   return 0;
}

int BhItemList::RentalList(BhRentalList *, bool bShow)
{
   refls->clear();
   
   get_column(0)->set_title(_("Name"));   
   get_column(1)->set_title(_("I"));
   get_column(2)->set_title(_("Description"));
   get_column(3)->set_title(_("Out On"));
   get_column(4)->set_title(_("Sub"));
   
   return 0;
}

int BhItemList::RentalReturn(BhRentalList *, bool bShow)
{
   return 0;
}

int BhItemList::Layby(CTransItems&, bool bShow)
{
   return 0;
}

int BhItemList::LaybySummary(BhLaybyList *, bool bShow)
{
   refls->clear();
   
   get_column(0)->set_title(_("TransID"));   
   get_column(1)->set_title(_("Price"));
   get_column(2)->set_title(_("Description"));
   get_column(3)->set_title(_("Paid"));
   get_column(4)->set_title(_("Due"));
   
   return 0;
}

int BhItemList::LaybyList(BhLaybyList *, bool bShow)
{
   return 0;
}

int BhItemList::LaybyPay(BhLaybyList *, bool bShow)
{
   return 0;
}

int BhItemList::ReturnReason(BhReturnReasonList *rl, bool bShow)
{
   return 0;
}
*/
int BhItemList::PriceList(BhPriceList *pl, bool bShow)
{
   if(bShow){
      if(pl==NULL) return 1;
      get_column(0)->set_title(_(""));   
      get_column(1)->set_title(_("ID"));
      get_column(2)->set_title(_("Name"));
      get_column(3)->set_title(_(""));
      get_column(4)->set_title(_(""));
      
      BhPriceListItem *pli=pl->item;
      BhPriceListItem *tpl;
      char                 cbuff[64];
      Glib::ustring        buff;
      Gtk::TreeModel::Row  row;
      
      for(int i=0; i < pl->numitems; i++){
         row = *(refls->append());
         sprintf(cbuff, "%d", pli->ID);
         buff=cbuff;
         row[columns.quantity]=buff;
         buff=pli->name;
         row[columns.description]=buff;
         g_print("price items:%d - %s\n",pli->ID, pli->name);
         pli++;
      }
      //set_cursor(path, *get_column(0), true);
      refSelection->select(row);
   }
   else{
      refls->clear();
      get_column(0)->set_title(_("PLU"));
      get_column(1)->set_title(_("Qty"));
      get_column(2)->set_title(_("Description"));
      get_column(3)->set_title(_("Price"));
      get_column(4)->set_title(_("Sub"));
   }
   return 0;
}
/*
int BhItemList::OpenTransList(BhTransRoverList *rl, bool bShow)
{
   return 0;
}

int BhItemList::OpeningBalance(CCash& cashd, bool bShow)
{
   refls->clear();
   
   get_column(0)->set_title("");   
   get_column(1)->set_title("");
   get_column(2)->set_title(_("Unit"));
   get_column(3)->set_title(_("Qty"));
   get_column(4)->set_title(_("Sub"));
   
   return 0;
}

int BhItemList::BlindBalance(BhBlindBalanceReply *, bool bShow)
{
   return 0;
}
*/

void BhItemList::SetOption(BhItemListOption o, void *v)
{
   switch(o){
   case BHITEMLIST_OPTION_TAXINCLUSIVE:
      bTaxInclusive=*((bool *) v);
      break;
   }
}

void BhItemList::Resize()
{
   double z;
   int    s, y, x, t=0;
   
   get_size_request(s, y);
   if(s < 1) return;
      
   z=100/s;
   x=(int) z*9;
   t+=x;
   get_column(1)->set_fixed_width(x);
   x=(int) z*11;
   t+=x;
   get_column(3)->set_fixed_width(x);
   get_column(4)->set_fixed_width(x);
   z=s/100;
   z=110/z;
   x=t-(int) z;
   get_column(2)->set_fixed_width(t);
}

int BhItemList::Load(CTransItems& transaction)
{
   Update(transaction);
   return 0;
}

void BhItemList::Clear()
{
   refls->clear();
   refSelection->unselect_all();
   num_rows=0;
   due=0;
   if(!refls){
      refls = Gtk::TreeStore::create(columns);
      set_model(refls);
   }
   //queue_draw();
}

void BhItemList::SetMode(BhItemListMode m, void *data)
{
   if(mode==m) return;

   Gtk::TreeRow   row;
   Gtk::TreeModel::iterator iter;
   BhItemListMode old_mode=mode;
   
   mode=m;
   switch(m){
   case BHITEMLIST_MODE_IDLE:
      break;
   
   case BHITEMLIST_MODE_PRICELIST:
      //bhmfengine::PriceList *plst=(bhmfengine::PriceList *) data;
      break;
   
   case BHITEMLIST_MODE_SALE:
      if(old_mode==BHITEMLIST_MODE_TENDERTYPE){
         PayMode(0, false);
      }
      break;
      
   case BHITEMLIST_MODE_QTYEDIT:
   case BHITEMLIST_MODE_WAIT:
      break;
      
   case BHITEMLIST_MODE_TENDERTYPE:
   {
      iter = refSelection->get_selected();
      row=*iter;
      
      double amount=*((double *) data);
      PayMode(amount, true);
      due=amount;
      
      //row = *(refls->append());
      //row[columns.type]=BHITEMLIST_TYPE_BLANK;
      //row = *(refls->append());
      //Gtk::TreeModel::Path path(row);
      //row[columns.type]=BHITEMLIST_TYPE_TENDERTYPE;
      //row[columns.status]=BHITEMLIST_STATUS_TENDERTYPE;
      //set_cursor(path, *get_column(3), true);
      // renderer type combo... ?
   }
      break;
      
   case BHITEMLIST_MODE_TENDERAMOUNT:
      //cell_col3->property_editable() = false;
      //cell_col4->property_editable() = true;
      //set_cursor(path, *get_column(4), true);
      //break;
   
   case BHITEMLIST_MODE_TRANSLIST:
      break;
   }
}

BhItemListMode BhItemList::GetMode()
{
   return mode;
}

int BhItemList::TransList(BhSSTransList *tl, bool bShow)
{
   char                 cbuff[64];
   Glib::ustring        buff;
   Gtk::TreeModel::Row  row;
   BhSSTransListItem     *item=tl->items;
   
   refls->clear();
   
   if(bShow){
      get_column(0)->set_title(_("Started"));   
      get_column(1)->set_title(_("Items"));
      get_column(2)->set_title(_("Name"));
      get_column(3)->set_title(_("Total"));
      get_column(4)->set_title(_("Status"));
      
      for(int i=0; i < tl->num_items; i++){
         sprintf(cbuff, "%012d", item->timestamp);
         buff=cbuff;
         row[columns.plu]=buff;
         
         sprintf(cbuff, "%d", item->num_items);
         buff=cbuff;
         row[columns.quantity]=buff;
         
         sprintf(cbuff, "%0.2f", item->total);
         buff=cbuff;
         row[columns.subtotal]=buff;
         
         row[columns.type]=item->id;
         
         row[columns.description]=item->name;
         
         switch(item->status){
         case BHTRANS_STATUS_OPEN:    buff="Ready"; break;
         case BHTRANS_STATUS_TENDER:  buff="Tender"; break;
         case BHTRANS_STATUS_PAYAUTH: buff="Payment"; break;
         }
         row[columns.total]=buff;
         
         item++;
      }
   }
   else{
   }
   
   return 0;
}

int BhItemList::TransList(BhTransList *tl, bool bShow)
{
   char                 cbuff[64];
   Glib::ustring        buff;
   Gtk::TreeModel::Row  row;
   BhTransListItem     *item=tl->items;
   
   refls->clear();
   
   if(bShow){
      get_column(0)->set_title(_("Started"));   
      get_column(1)->set_title(_("Items"));
      get_column(2)->set_title(_("Name"));
      get_column(3)->set_title(_("Total"));
      get_column(4)->set_title(_("Status"));
      
      for(int i=0; i < tl->num_items; i++){
         sprintf(cbuff, "%012d", item->timestamp);
         buff=cbuff;
         row[columns.plu]=buff;
         
         sprintf(cbuff, "%d", item->num_items);
         buff=cbuff;
         row[columns.quantity]=buff;
         
         sprintf(cbuff, "%0.2f", item->total);
         buff=cbuff;
         row[columns.subtotal]=buff;
         
         row[columns.type]=item->id;
         
         row[columns.description]="Sale";
         
         switch(item->status){
         case BHTRANS_STATUS_OPEN:    buff="Ready"; break;
         case BHTRANS_STATUS_TENDER:  buff="Tender"; break;
         case BHTRANS_STATUS_PAYAUTH: buff="Payment"; break;
         }
         row[columns.total]=buff;
         
         item++;
      }
   }
   else{
   }
   
   return 0;
}

bool BhItemList::Get(double *amount)
{
   refSelection=get_selection();
   Glib::ustring        buff;
   char                 cbuff[64];
   Gtk::TreeModel::Row  row=*curr_row;
   
   buff=row[columns.subtotal];
   if(buff=="") return true;
   strcpy(cbuff, buff.data());
   sprintf(cbuff, "0.2f", cbuff);
   buff=cbuff;
   row[columns.subtotal]=buff;
   *amount=atof(cbuff);
   due-=*amount;
   cell_col3->property_editable()=false;
   cell_col3->property_editable_set()=false;
   if(due < 0.0){
   }
   sprintf(cbuff, "%0.2f", due);
   buff=cbuff;
   row[columns.subtotal]=buff;
   mode=BHITEMLIST_MODE_TENDERTYPE;
   return false;
}

bool BhItemList::Get(int *qty)
{
   Gtk::TreeModel::iterator iter = refSelection->get_selected();
   Glib::ustring        buff;
   char                 cbuff[64];
   Gtk::TreeModel::Row  row=*iter;
   
   buff=row[columns.quantity];
   if(buff==""){
      *qty=1;
      return true;
   }
   *qty=atoi(buff.data());
   return false;
}

void BhItemList::Append(CSaleItem *saleitem)
{
   Glib::ustring        buff;
   char                 cbuff[64];
   int                  n;
   double               price;
   Gtk::TreeModel::Row  row;
   
   row = *(refls->append());
   num_rows++;
   row_height = (int) scroll_win->get_vadjustment()->get_upper() / num_rows;
   
   row[columns.plu]=saleitem->GetPLU();
   sprintf(cbuff, "%d", saleitem->GetQuantity());
   row[columns.quantity]=cbuff;
   row[columns.description]=saleitem->GetDispText();
   
   switch(saleitem->GetType()){
   case BHSI_SITYPE_UPLU:
      row[columns.type]=BHITEMLIST_TYPE_UNKNOWN;
      break;

   case BHSI_SITYPE_PLU:
      row[columns.type]=BHITEMLIST_TYPE_ITEM;
      break;
   
   case BHSI_SITYPE_PRICE:
      row[columns.type]=BHITEMLIST_TYPE_UNKNOWN;
      break;
   
   case BHSI_SITYPE_DESCPRICE:
      row[columns.type]=BHITEMLIST_TYPE_UNKNOWN;
      break;
   
   case BHSI_SITYPE_ALL:
      break;
   
   case BHSI_SITYPE_RETURN:
      buff=_("(R) ");
      buff+=saleitem->GetDispText();
      row[columns.description]=buff;
      row[columns.type]=BHITEMLIST_TYPE_RETURN;

      break;
   
	case BHSI_SITYPE_LAYBY:
      buff=_("(L) ");
      buff+=saleitem->GetDispText();
      row[columns.description]=buff;
      row[columns.type]=BHITEMLIST_TYPE_LAYBY;
      break;
   
   case BHSI_SITYPE_DETAIL:
      buff=_("(T) ");
      buff+=saleitem->GetDispText();
      row[columns.description]=buff;
      row[columns.type]=BHITEMLIST_TYPE_DETAIL;
      break;

	case BHSI_SITYPE_DELIVERY:
      buff=_("(D) ");
      buff+=saleitem->GetDispText();
      row[columns.description]=buff;
      row[columns.type]=BHITEMLIST_TYPE_DELIVERY;
      break;
   
	case BHSI_SITYPE_UNDELIVERED:
      buff=_("(U) ");
      buff+=saleitem->GetDispText();
      row[columns.description]=buff;
      row[columns.type]=BHITEMLIST_TYPE_UNDELIVERED;
      break;
   
	case BHSI_SITYPE_RENTAL:
      buff=_("(N) ");
      buff+=saleitem->GetDispText();
      row[columns.description]=buff;
      row[columns.type]=BHITEMLIST_TYPE_RENTAL;
      break;
   
	case BHSI_SITYPE_RENTALRETURN:
      buff=_("(T) ");
      buff+=saleitem->GetDispText();
      row[columns.description]=buff;
      row[columns.type]=BHITEMLIST_TYPE_RENTALRETURN;
      break;
   
	case BHSI_SITYPE_EPHEMERAL:
      buff=_("(E) ");
      buff+=saleitem->GetDispText();
      row[columns.description]=buff;
      break;
   }
   /*
   switch(saleitem->GetDepositType()){
   case BHSI_DEPOSIT_NONE:
      break;
   case BHSI_DEPOSIT_REFUNDABLE:
   {
      buff=saleitem->GetDepositName();
      Gtk::TreeModel::iterator iter_child = refls->append(row.children());
      last_row = *(iter_child);
      last_row[columns.description]=buff;
      sprintf(cbuff, "%0.2f", saleitem->GetDeposit());
      buff=cbuff;
      last_row.set_value(columns.subtotal, buff);
      sprintf(cbuff, "%0.2f", saleitem->GetDeposit()*saleitem->GetQuantity());
      buff=cbuff;
      last_row[columns.total]=buff;
   }
      break;
   case BHSI_DEPOSIT_REDEMPTION:
   {
      buff=saleitem->GetDepositName();
      Gtk::TreeModel::iterator iter_child = refls->append(row.children());
      last_row = *(iter_child);      last_row[columns.description]=buff;
      sprintf(cbuff, "%0.2f", saleitem->GetDeposit());
      buff=cbuff;
      last_row[columns.subtotal]=buff;
      sprintf(cbuff, "%0.2f", saleitem->GetDeposit()*saleitem->GetQuantity());
      buff=cbuff;
      last_row[columns.total]=buff;
   }
      break;
   }
   
   if(saleitem->GetFlags()){
      if(saleitem->GetMsg()!=NULL){
         buff=saleitem->GetMsg();
         Gtk::TreeModel::iterator iter_child = refls->append(row.children());
         last_row = *(iter_child);
         last_row[columns.description]=buff;
      }
   }
   */
   price=(saleitem->GetPrice() - (saleitem->GetPrice() * saleitem->GetDiscount()));
	if(bTaxInclusive){
      sprintf(cbuff, "%0.2f", (price + (price * saleitem->GetTax())));
      buff=cbuff;
      row[columns.subtotal] = buff;
      price=price*saleitem->GetQuantity();
      //g_print("bhitemlist tax inclu qty/total: %d %0.2f %f", saleitem->GetQuantity(), price, saleitem->GetTax());
      sprintf(cbuff, "%0.2f", (price + (price * saleitem->GetTax())));
      buff=cbuff;
      row[columns.total] = buff;
   }
   else{
	   sprintf(cbuff, "%0.2f", price);
      buff=cbuff;
      row[columns.subtotal]=buff;
      price=price*saleitem->GetQuantity();
      //g_print("bhitemlist tax ninclu qty/total: %d %0.2f\n", saleitem->GetQuantity(), price);
      sprintf(cbuff, "%0.2f", price);
      //g_print(" ---%s---\n", cbuff);
      buff=cbuff;
      row[columns.total]=buff;
	}
   SetRowColour(row);
   row[columns.status]=BHITEMLIST_STATUS_FIXED;
   mode=BHITEMLIST_MODE_SALE;
   refSelection->unselect_all();
}

int BhItemList::Add(BhItemListItemFlag flag, CSaleItem *saleitem)
{
   Glib::ustring        buff;
   char                 cbuff[64];
   int                  n;
   double               price;
   Gtk::TreeModel::Row  row;
   Gtk::TreeModel::Row  last_row;
   
   refSelection=get_selection();
   Gtk::TreeModel::iterator iter = refSelection->get_selected();

   if(bHaveRow){
      row = *curr_row;
      last_row=row;
   }
   else{
      if(iter){ // have selected row...
         row = *iter;
         last_row=row;
      }  
      else{ // else append
         row = *(refls->append());
         num_rows++;
         row_height = (int) scroll_win->get_vadjustment()->get_upper() / num_rows;
      }
   }
   // check last row drop...
   {
      Gtk::TreeModel::Path path(row);
      buff=row[columns.quantity];
      n=atoi(buff.data());
      path.prev();
      iter=refls->get_iter(path);
      if(iter){
         last_row=*iter;
         if(last_row[columns.status]==BHITEMLIST_STATUS_DROPNEXT){
            refls->erase(*iter);
            num_rows--;
            row_height = (int) scroll_win->get_vadjustment()->get_upper() / num_rows;
         }
      }
   }
   
   switch(saleitem->GetType()){
   case BHSI_SITYPE_UPLU:
   {
      Gtk::TreeModel::Path path(row);
      row[columns.status]=BHITEMLIST_STATUS_ADD;
      cell_col0->property_editable_set()=false;
      cell_col0->property_editable() = false;
      cell_col1->property_editable() = false;
      cell_col2->property_editable() = true;
      cell_col3->property_editable() = true;
      cell_col2->property_editable_set()=true;
      //buff=saleitem->GetDispText();
      //Glib::RefPtr<Pango::Layout> pl = create_pango_layout(buff);
      // drop next 
      if(flag==BHITEMLIST_ITEMFLAG_DROPNEXT){
         row[columns.status]=BHITEMLIST_STATUS_DROPNEXT;
         row[columns.type]=BHITEMLIST_TYPE_LOOKUP;
      }
      else{
         row[columns.status]=BHITEMLIST_STATUS_FIXED;
         row[columns.type]=BHITEMLIST_TYPE_UNKNOWN;
      }
      SetRowColour(row);
      //row[columns.description]=buff;
      mode=BHITEMLIST_MODE_SALE;
      grab_focus();
      set_cursor(path, *get_column(2), true);
      return false;
   }
      break;

   case BHSI_SITYPE_PLU:
   {
      bHaveRow=false;
      Gtk::TreeModel::Path path(row);
      if(num_rows!=0){
         buff=row[columns.quantity];
         n=atoi(buff.data());
         buff=row[columns.plu];
         path.prev();
         iter=refls->get_iter(path);
         if(iter){
            last_row=*iter;
            if(last_row[columns.plu]==buff){
               Glib::ustring        tempbuff;
               tempbuff=last_row[columns.plu];
            
               //g_print("same plu:%s - %s\n", buff.data(), tempbuff.data());
               num_rows--;
               if(num_rows==0) num_rows=1;
               row_height = (int) scroll_win->get_vadjustment()->get_upper() / num_rows;
               buff=last_row[columns.quantity];
               n+=atoi(buff.data());
               sprintf(cbuff, "%d", n);
               buff=cbuff;
               last_row[columns.quantity]=buff;
               Gtk::TreeModel::Path o_path(row);
               iter=refls->get_iter(o_path);
               if(iter){
                  refls->erase(*iter);
               }
               Gtk::TreeModel::Path n_path(last_row);
               set_cursor(n_path);
               iter=refls->get_iter(n_path);
               row = *iter;
            }
            else{
               row[columns.description]=saleitem->GetDispText();
               if(flag==BHITEMLIST_ITEMFLAG_DROPNEXT){
                  row[columns.status]=BHITEMLIST_STATUS_DROPNEXT;
                  row[columns.type]=BHITEMLIST_TYPE_LOOKUP;
               }
               else{
                  row[columns.status]=BHITEMLIST_STATUS_FIXED;
                  row[columns.type]=BHITEMLIST_TYPE_ITEM;
               }
               SetRowColour(row);
            }
         }
         else{
            //g_print("no iter\n");
         }
      }
      else{
         row[columns.description]=saleitem->GetDispText();
         // drop next 
         if(flag==BHITEMLIST_ITEMFLAG_DROPNEXT){
            row[columns.status]=BHITEMLIST_STATUS_DROPNEXT;
            row[columns.type]=BHITEMLIST_TYPE_LOOKUP;
         }
         else{
            row[columns.status]=BHITEMLIST_STATUS_FIXED;
            row[columns.type]=BHITEMLIST_TYPE_ITEM;
         }
         SetRowColour(row);
      }
      completion_signal.emit(BHITEMLIST_COMPLETION_PLU, NULL, NULL);
   }
      break;
   
   case BHSI_SITYPE_PRICE:
   {
      Gtk::TreeModel::Path path(row);
      row[columns.status]=BHITEMLIST_STATUS_PRICEEDIT;
      buff=saleitem->GetDispText();
      row[columns.type]=BHITEMLIST_TYPE_UNKNOWN;
      row[columns.description]=buff;
      cell_col0->property_editable_set()=false;
      cell_col0->property_editable() = false;
      cell_col1->property_editable() = false;
      cell_col3->property_editable() = true;
      cell_col3->property_editable_set()=true;
      grab_focus();
      set_cursor(path, *get_column(3), true);
      mode=BHITEMLIST_MODE_SALE;
      return 0;
   }
      break;
   
   case BHSI_SITYPE_DESCPRICE:
   {
      Gtk::TreeModel::Path path(row);
      row[columns.status]=BHITEMLIST_STATUS_DESCEDIT;
      buff=saleitem->GetDispText();
      row[columns.type]=BHITEMLIST_TYPE_UNKNOWN;
      row[columns.description]=buff;
      cell_col0->property_editable_set()=false;
      cell_col0->property_editable() = false;
      cell_col1->property_editable() = false;
      cell_col2->property_editable() = true;
      cell_col3->property_editable() = true;
      cell_col2->property_editable_set()=true;
      grab_focus();
      set_cursor(path, *get_column(2), true);
      mode=BHITEMLIST_MODE_SALE;
      return 0;
   }
      break;
   
   case BHSI_SITYPE_ALL:
      break;
   
   case BHSI_SITYPE_RETURN:
      buff=_("(R) ");
      buff+=saleitem->GetDispText();
      row[columns.description]=buff;
      row[columns.type]=BHITEMLIST_TYPE_RETURN;

      break;
   
	case BHSI_SITYPE_LAYBY:
      buff=_("(L) ");
      buff+=saleitem->GetDispText();
      row[columns.description]=buff;
      row[columns.type]=BHITEMLIST_TYPE_LAYBY;
      break;
   
   case BHSI_SITYPE_DETAIL:
      buff=_("(T) ");
      buff+=saleitem->GetDispText();
      row[columns.description]=buff;
      row[columns.type]=BHITEMLIST_TYPE_DETAIL;
      break;

	case BHSI_SITYPE_DELIVERY:
      buff=_("(D) ");
      buff+=saleitem->GetDispText();
      row[columns.description]=buff;
      row[columns.type]=BHITEMLIST_TYPE_DELIVERY;
      break;
   
	case BHSI_SITYPE_UNDELIVERED:
      buff=_("(U) ");
      buff+=saleitem->GetDispText();
      row[columns.description]=buff;
      row[columns.type]=BHITEMLIST_TYPE_UNDELIVERED;
      break;
   
	case BHSI_SITYPE_RENTAL:
      buff=_("(N) ");
      buff+=saleitem->GetDispText();
      row[columns.description]=buff;
      row[columns.type]=BHITEMLIST_TYPE_RENTAL;
      break;
   
	case BHSI_SITYPE_RENTALRETURN:
      buff=_("(T) ");
      buff+=saleitem->GetDispText();
      row[columns.description]=buff;
      row[columns.type]=BHITEMLIST_TYPE_RENTALRETURN;
      break;
   
	case BHSI_SITYPE_EPHEMERAL:
      buff=_("(E) ");
      buff+=saleitem->GetDispText();
      row[columns.description]=buff;
      break;
   }
   
   switch(saleitem->GetDepositType()){
   case BHSI_DEPOSIT_NONE:
      break;
   case BHSI_DEPOSIT_REFUNDABLE:
   {
      buff=saleitem->GetDepositName();
      Gtk::TreeModel::iterator iter_child = refls->append(row.children());
      last_row = *(iter_child);
      last_row[columns.description]=buff;
      sprintf(cbuff, "%0.2f", saleitem->GetDeposit());
      buff=cbuff;
      last_row.set_value(columns.subtotal, buff);
      sprintf(cbuff, "%0.2f", saleitem->GetDeposit()*saleitem->GetQuantity());
      buff=cbuff;
      last_row[columns.total]=buff;
   }
      break;
   case BHSI_DEPOSIT_REDEMPTION:
   {
      buff=saleitem->GetDepositName();
      Gtk::TreeModel::iterator iter_child = refls->append(row.children());
      last_row = *(iter_child);      last_row[columns.description]=buff;
      sprintf(cbuff, "%0.2f", saleitem->GetDeposit());
      buff=cbuff;
      last_row[columns.subtotal]=buff;
      sprintf(cbuff, "%0.2f", saleitem->GetDeposit()*saleitem->GetQuantity());
      buff=cbuff;
      last_row[columns.total]=buff;
   }
      break;
   }
   
   if(saleitem->GetFlags()){
      if(saleitem->GetMsg()!=NULL){
         buff=saleitem->GetMsg();
         Gtk::TreeModel::iterator iter_child = refls->append(row.children());
         last_row = *(iter_child);
         last_row[columns.description]=buff;
      }
   }
   
   price=(saleitem->GetPrice() - (saleitem->GetPrice() * saleitem->GetDiscount()));
	if(bTaxInclusive){
      sprintf(cbuff, "%0.2f", (price + (price * saleitem->GetTax())));
      buff=cbuff;
      row[columns.subtotal] = buff;
      price=price*saleitem->GetQuantity();
      //g_print("bhitemlist tax inclu qty/total: %d %0.2f %f", saleitem->GetQuantity(), price, saleitem->GetTax());
      sprintf(cbuff, "%0.2f", (price + (price * saleitem->GetTax())));
      buff=cbuff;
      row[columns.total] = buff;
   }
   else{
	   sprintf(cbuff, "%0.2f", price);
      buff=cbuff;
      row[columns.subtotal]=buff;
      price=price*saleitem->GetQuantity();
      //g_print("bhitemlist tax ninclu qty/total: %d %0.2f\n", saleitem->GetQuantity(), price);
      sprintf(cbuff, "%0.2f", price);
      //g_print(" ---%s---\n", cbuff);
      buff=cbuff;
      row[columns.total]=buff;
	}
   
   row[columns.status]=BHITEMLIST_STATUS_FIXED;
   mode=BHITEMLIST_MODE_SALE;
   refSelection->unselect_all();

   return 0;
}

int BhItemList::Add(CPayItem& payitem)
{
   
   return 0;
}

int BhItemList::AddPayType(BhPayType paytype)
{
   Glib::ustring buff;
   Gtk::TreeModel::Row  row;
   
   row = *(refls->append());
   
   switch(paytype){
	case PTYPE_UNKNOWN: buff=_(""); row[columns.type]=BHITEMLIST_TYPE_TENDERTYPE_UNKNOWN; break;
	case PTYPE_CASH:   buff=_("Cash"); row[columns.type]=BHITEMLIST_TYPE_TENDERTYPE_CASH; break;
	case PTYPE_CREDIT: buff=_("Credit"); row[columns.type]=BHITEMLIST_TYPE_TENDERTYPE_CREDIT; break;
	case PTYPE_CHEQUE: buff=_("Cheque"); row[columns.type]=BHITEMLIST_TYPE_TENDERTYPE_CHEQUE; break;
	case PTYPE_SMARTC: buff=_("Smart"); row[columns.type]=BHITEMLIST_TYPE_TENDERTYPE_SMART; break;
	case PTYPE_CREDITRETURN:  buff=_("Credit Return"); row[columns.type]=BHITEMLIST_TYPE_TENDERTYPE_CREDITRETURN; break;
   case PTYPE_CREDITSLIP:  buff=_("Credit Slip"); row[columns.type]=BHITEMLIST_TYPE_TENDERTYPE_CREDITSLIP; break;   
	case PTYPE_GIFTVOUCHER:  buff=_("Gift Voucher"); row[columns.type]=BHITEMLIST_TYPE_TENDERTYPE_GIFTV; break;
	case PTYPE_TPVOUCHER:  buff=_("External Voucher"); row[columns.type]=BHITEMLIST_TYPE_TENDERTYPE_EXTVOUCHER; break;
	case PTYPE_INTCOUPON: buff=_("Internal Coupon"); row[columns.type]=BHITEMLIST_TYPE_TENDERTYPE_INTCOUPON; break;
   case PTYPE_TPCOUPON:  buff=_("External Coupon"); row[columns.type]=BHITEMLIST_TYPE_TENDERTYPE_EXTCOUPON; break;
	case PTYPE_LUNCHSTAMP:  buff=_("Lunch Stamps"); row[columns.type]=BHITEMLIST_TYPE_TENDERTYPE_LUNCHSTAMP; break;
   case PTYPE_INHOUSECHARGE: buff=_("In-house Charge"); row[columns.type]=BHITEMLIST_TYPE_TENDERTYPE_INHOUSECHARGE; break;
   case PTYPE_STORECARD:  buff=_("Store Card"); row[columns.type]=BHITEMLIST_TYPE_TENDERTYPE_STORECARD; break;
	case PTYPE_OTHER:  buff=_("Other"); row[columns.type]=BHITEMLIST_TYPE_TENDERTYPE_OTHER; break;
	case PTYPE_CREDIT_CB: buff=_("Credit (Cash Back)"); row[columns.type]=BHITEMLIST_TYPE_TENDERTYPE_CREDITCB; break;
	case PTYPE_CHEQUE_CB: buff=_("Cheque (Cash Back)"); row[columns.type]=BHITEMLIST_TYPE_TENDERTYPE_CHEQUECB; break;
	case PTYPE_SMARTC_CB: buff=_("Smart (Cash Back)"); row[columns.type]=BHITEMLIST_TYPE_TENDERTYPE_SMARTCB; break;
	case PTYPE_TOKEN_CB:  buff=_("Token (Cash Back)"); row[columns.type]=BHITEMLIST_TYPE_TENDERTYPE_TOKENCB; break;
	case PTYPE_VOUCHER_CB:  buff=_("Voucher (Cash Back)"); row[columns.type]=BHITEMLIST_TYPE_TENDERTYPE_VOUCHERCB; break;
	case PTYPE_COUPON_CB:  buff=_("Coupon (Cash Back)"); row[columns.type]=BHITEMLIST_TYPE_TENDERTYPE_COUPONCB; break;
	case PTYPE_OTHER_CB:  buff=_("Other (Cash Back)"); row[columns.type]=BHITEMLIST_TYPE_TENDERTYPE_OTHERCB; break;
	}
   
   curr_payitem.SetID(paytype);
   
   row[columns.description]=buff;
   row[columns.status]=BHITEMLIST_STATUS_AMOUNTEDIT;
   refSelection->unselect_all();
   cell_col3->property_editable_set()=true;
   cell_col3->property_editable() = true;
   grab_focus();
   Gtk::TreeModel::Path path(row);
   set_cursor(path, *get_column(3), true);
   mode=BHITEMLIST_MODE_TENDERAMOUNT;
   curr_row=row;
   //SetRowColour(row);
   
   return 0;
}

bool BhItemList::FindRow(Gtk::TreeModel::Row& row, Glib::ustring plu)
{
   Gtk::TreeModel::Row r;
   Gtk::TreeModel::Children children = refls->children();
   if(plu=="") return false;
   for(Gtk::TreeModel::Children::iterator iter = children.begin(); iter != children.end(); ++iter){
       r=*iter;
      if(r[columns.plu]==plu){
         row=r;
         return  true;
      }
   }
   return false;
}

bool BhItemList::FindRow(Gtk::TreeModel::Row& row, CSaleItem& si)
{
   Glib::ustring plu=si.GetPLU();
   Gtk::TreeModel::Row r;
   Gtk::TreeModel::Children children = refls->children();
   if(plu=="") return false;
   for(Gtk::TreeModel::Children::iterator iter = children.begin(); iter != children.end(); ++iter){
       r=*iter;
      if(r[columns.plu]==plu){
         row=r;
         return  true;
      }
   }
   return false;
}

bool BhItemList::FindRow(Gtk::TreeModel::Row& row, CPayItem& pi)
{
   BhItemListItemType type=PayType(pi.GetID());
   
   Gtk::TreeModel::Row r;
   Gtk::TreeModel::Children children = refls->children();
   for(Gtk::TreeModel::Children::iterator iter = children.begin(); iter != children.end(); ++iter){
       r=*iter;
      if(r[columns.type]==type){
         row=r;
         return  true;
      }
   }
   return false;
}

BhItemListItemType BhItemList::PayType(BhPayType t)
{
   switch(t){
   case PTYPE_UNKNOWN: return BHITEMLIST_TYPE_TENDERTYPE_UNKNOWN;
   case PTYPE_CASH: return BHITEMLIST_TYPE_TENDERTYPE_CASH;
   case PTYPE_CREDIT: return BHITEMLIST_TYPE_TENDERTYPE_CREDIT;
   case PTYPE_CHEQUE: return BHITEMLIST_TYPE_TENDERTYPE_CHEQUE;
   case PTYPE_SMARTC: return BHITEMLIST_TYPE_TENDERTYPE_SMART;
   case PTYPE_CREDITRETURN: return BHITEMLIST_TYPE_TENDERTYPE_CREDITRETURN;
   case PTYPE_CREDITSLIP: return BHITEMLIST_TYPE_TENDERTYPE_CREDITSLIP;
   case PTYPE_GIFTVOUCHER: return BHITEMLIST_TYPE_TENDERTYPE_GIFTV;
   case PTYPE_TPVOUCHER: return BHITEMLIST_TYPE_TENDERTYPE_EXTVOUCHER;
   case PTYPE_INTCOUPON: return BHITEMLIST_TYPE_TENDERTYPE_INTCOUPON;
   case PTYPE_TPCOUPON: return BHITEMLIST_TYPE_TENDERTYPE_EXTCOUPON;
   case PTYPE_LUNCHSTAMP: return BHITEMLIST_TYPE_TENDERTYPE_LUNCHSTAMP;
   case PTYPE_INHOUSECHARGE: return BHITEMLIST_TYPE_TENDERTYPE_INHOUSECHARGE;
   case PTYPE_STORECARD: return BHITEMLIST_TYPE_TENDERTYPE_STORECARD;
   case PTYPE_OTHER: return BHITEMLIST_TYPE_TENDERTYPE_OTHER;
   case PTYPE_CREDIT_CB: return BHITEMLIST_TYPE_TENDERTYPE_CREDITCB;
   case PTYPE_CHEQUE_CB: return BHITEMLIST_TYPE_TENDERTYPE_CHEQUECB;
   case PTYPE_SMARTC_CB: return BHITEMLIST_TYPE_TENDERTYPE_SMARTCB;
   case PTYPE_TOKEN_CB: return BHITEMLIST_TYPE_TENDERTYPE_TOKENCB;
   case PTYPE_VOUCHER_CB: return BHITEMLIST_TYPE_TENDERTYPE_VOUCHERCB;
   case PTYPE_COUPON_CB: return BHITEMLIST_TYPE_TENDERTYPE_COUPONCB;
   case PTYPE_OTHER_CB: return BHITEMLIST_TYPE_TENDERTYPE_OTHERCB;
   }
   return BHITEMLIST_TYPE_TENDERTYPE_UNKNOWN;
}

int BhItemList::Edit(CSaleItem& oldsaleitem, CSaleItem& newsaleitem)
{
   return 0;
}

int BhItemList::Edit(CPayItem& oldpayitem, CPayItem& newpayitem)
{
   return 0;
}

int BhItemList::Edit(int row, CSaleItem& saleitem)
{
   return 0;
}

int BhItemList::Edit(int row, CPayItem& payitem)
{
   return 0;
}

int BhItemList::Edit(CSaleItem& saleitem)
{
   Gtk::TreeModel::Row row;
   Glib::ustring        buff;
   char                 cbuff[64];
   int                  n;
   double               price;
   
   if(FindRow(row, saleitem.GetPLU())){
      n=saleitem.GetQuantity();
      sprintf(cbuff, "%d",n);
      row[columns.quantity]=cbuff;
      price=(saleitem.GetPrice() - (saleitem.GetPrice() * saleitem.GetDiscount()));
	   if(bTaxInclusive){
         sprintf(cbuff, "%0.2f", (price + (price * saleitem.GetTax())));
         buff=cbuff;
         row[columns.subtotal] = buff;
         price=price*saleitem.GetQuantity();
         sprintf(cbuff, "%0.2f", (price + (price * saleitem.GetTax())));
         buff=cbuff;
         row[columns.total] = buff;
      }
      else{
	      sprintf(cbuff, "%0.2f", price);
         buff=cbuff;
         row[columns.subtotal]=buff;
         price=price*saleitem.GetQuantity();
         sprintf(cbuff, "%0.2f", price);
         buff=cbuff;
         row[columns.total]=buff;
	   }
   }
   return 0;
}

int BhItemList::Edit(CPayItem& payitem)
{
   Gtk::TreeModel::Row row;
   Glib::ustring        buff;
   char                 cbuff[64];
   double               a;
   
   if(FindRow(row, payitem)){
      a=payitem.GetAmount();
      buff=row[columns.subtotal];
      a+=atof(buff.data());
      sprintf(cbuff, "%0.2f", a);
      row[columns.subtotal]=cbuff;
   }
   return 0;
}

int BhItemList::Remove(CSaleItem& saleitem)
{
   Gtk::TreeModel::Row row;
   
   if(FindRow(row, saleitem.GetPLU())){
      refls->erase(row);
      num_rows--;
   }
   
   return 0;
}

int BhItemList::Remove(CPayItem& payitem)
{
   return 0;
}

int BhItemList::Remove(int row)
{
   return 0;
}

bool BhItemList::Action(BhListActionType action, void *item)
{
   bool                 ret=false;
   int                  n=0;
   double               d;
   char                 cbuff[16];
   Glib::ustring        buff;
   Gtk::TreeModel::Row  row;

   if(!refls){
      // bum ref ptr
      g_print("bum refptr for treestore\n");
      refls = Gtk::TreeStore::create(columns);
      set_model(refls);
   }
   refSelection=get_selection();
   Gtk::TreeModel::iterator iter = refSelection->get_selected();
   Gtk::TreeModel::iterator citer = refSelection->get_selected();
   if(iter){
      row = *iter;
   }
   else{
      //return false;
   }
   
   buff="";
   
   switch(action){
   case BHITEMLIST_ACTION_NEW:
   {
      refSelection->unselect_all();
	   row = *(refls->append());
      buff=*((Glib::ustring *) item);
      Gtk::TreeModel::Path path(row);
      row[columns.status]=BHITEMLIST_STATUS_PLUEDIT;
      cell_col0->property_editable() = true;
      grab_focus();
      row[columns.quantity]="1";
      cell0_oldtext=buff;
      row[columns.plu]=buff;
      set_cursor(path, *get_column(0), true);
      refSelection->select(row);
      mode=BHITEMLIST_MODE_SALE;
   }
      break;
  
   case BHITEMLIST_ACTION_KEY:
      break;
   
   case BHITEMLIST_ACTION_SCANPLU:
   {
      refSelection->unselect_all();
      buff=*((Glib::ustring *) item);
      if(iter){
         row=*iter;
      }
      else{
         row = *(refls->append());
         row[columns.quantity]="1";
      }
      Gtk::TreeModel::Path path(row);
      grab_focus();
      row[columns.plu]=buff;
      refSelection->select(row);
      curr_row=refSelection->get_selected();
      bHaveRow=true;
      row[columns.status]=BHITEMLIST_STATUS_PLUSCAN;
      mode=BHITEMLIST_MODE_SALE;
   }
      break;
   
   case BHITEMLIST_ACTION_SELPLU:
   {
      buff=*((Glib::ustring *) item);
      refSelection->unselect_all();
      Gtk::TreeModel::Row  row=*iter;
      Gtk::TreeModel::Path path(row);
      row[columns.status]=BHITEMLIST_STATUS_ADD;
      cell_col0->property_editable_set()=true;
      cell_col0->property_editable() = true;
      grab_focus();
      curr_row=refSelection->get_selected();
      bHaveRow=true;
      set_cursor(path, *get_column(0), true);
      row[columns.plu]=buff;
      refSelection->select(row);
   }
      break;
   
   case BHITEMLIST_ACTION_QTYNEW:
   {
      row = *(refls->append());
      Gtk::TreeModel::Path path(row);
      row[columns.status]=BHITEMLIST_STATUS_QTYEDIT;
      cell_col1->property_editable_set()=true;
      cell_col1->property_editable() = true;
      cell_col0->property_editable_set()=true;
      cell_col0->property_editable() = true;
      grab_focus();
      refSelection->select(row);
      set_cursor(path, *get_column(1), true);
   }
      break;
   
   case BHITEMLIST_ACTION_QTYCHANGE:
   {
      Gtk::TreeModel::Path path(row);
      row[columns.status]=BHITEMLIST_STATUS_QTYEDIT;
      cell_col1->property_editable_set()=true;
      cell_col1->property_editable() = true;
      cell_col0->property_editable_set()=true;
      cell_col0->property_editable() = true;
      row[columns.plu]="";
      grab_focus();
      set_cursor(path, *get_column(1), true);
   }
      break;
   
   case BHITEMLIST_ACTION_QTYMOVE:
   {
      row[columns.status]=BHITEMLIST_STATUS_PLUEDIT;
      cell_col1->property_editable_set()=false;
      cell_col1->property_editable() = false;
      cell_col0->property_editable_set()=true;
      cell_col0->property_editable() = true;
      buff=row[columns.plu];
      n=atoi(buff.data());
      sprintf(cbuff, "%d", n);
      row[columns.quantity]=cbuff;
      row[columns.plu]="";
      grab_focus();
      Gtk::TreeModel::Path path(row);
      set_cursor(path, *get_column(0), true);
   }
      break;
   
   case BHITEMLIST_ACTION_INCNEW:
   {
      row = *(refls->append());
      Gtk::TreeModel::Path path(row);
      row[columns.status]=BHITEMLIST_STATUS_PLUEDIT;
      cell_col0->property_editable() = true;
      grab_focus();
      row[columns.quantity]="2";
      set_cursor(path, *get_column(0), true);
      refSelection->select(row);
   }
      break;
   
   case BHITEMLIST_ACTION_INCREMENT:
      if(iter){
         buff=row[columns.quantity];
         n=atoi(buff.c_str());
         n++;
         sprintf(cbuff, "%d", n);
         row[columns.quantity]=cbuff;
               
         buff=row[columns.subtotal];
         d=atof(buff.data());
         sprintf(cbuff, "%0.2f", d*n);
         row[columns.total]=cbuff;
         fillitem((CSaleItem *) item);
      }
      break;
      
   case BHITEMLIST_ACTION_INCMOVE:
   {
      Gtk::TreeModel::Path path(row);
      row[columns.status]=BHITEMLIST_STATUS_PLUEDIT;
      cell_col1->property_editable_set()=false;
      cell_col1->property_editable() = false;
      buff=row[columns.quantity];
      n=atoi(buff.data());
      n++;
      sprintf(cbuff, "%d", n);
      row[columns.quantity]=cbuff;
      grab_focus();
      refSelection->select(row);
      cell_col0->property_editable_set()=true;
      cell_col0->property_editable() = true;
      set_cursor(path, *get_column(0), true);
   }
      break;
   
   case BHITEMLIST_ACTION_INCEDIT: // in list edit
   {
      Gtk::TreeModel::Path path(row);
      row[columns.status]=BHITEMLIST_STATUS_PLUEDIT;
      cell_col1->property_editable_set()=false;
      cell_col1->property_editable() = false;
      buff=row[columns.quantity];
      n=atoi(buff.data());
      n++;
      sprintf(cbuff, "%d", n);
      row[columns.quantity]=cbuff;
      grab_focus();
      refSelection->select(row);
      /*
      buff=row[columns.plu];
      si->SetPLU(buff.data());
      buff=row[columns.quantity];
      si->SetQuantity(atoi(buff.data()));
      }*/
      fillitem((CSaleItem *) item);
      completion_signal.emit(BHITEMLIST_COMPLETION_INCEDIT, item, &i_curr_row);
   }
      break;
   
   case BHITEMLIST_ACTION_DECREMENT:
   {
      Gtk::TreeModel::Path path(row);
      row[columns.status]=BHITEMLIST_STATUS_PLUEDIT;
      cell_col1->property_editable_set()=false;
      cell_col1->property_editable() = false;
      cell_col0->property_editable_set()=true;
      cell_col0->property_editable() = true;
      buff=row[columns.quantity];
      n=atoi(buff.data());
      n--;
      if(n==0) n=1;
      sprintf(cbuff, "%d", n);
      row[columns.quantity]=cbuff;      
      grab_focus();
      refSelection->select(row);
      set_cursor(path, *get_column(0), true);
   }
      break;
   
   case BHITEMLIST_ACTION_DECEDIT: // in list edit
   {
      Gtk::TreeModel::Path path(row);
      row[columns.status]=BHITEMLIST_STATUS_PLUEDIT;
      cell_col1->property_editable_set()=false;
      cell_col1->property_editable() = false;
      buff=row[columns.quantity];
      n=atoi(buff.data());
      n--;
      fillitem((CSaleItem *) item);
      if(n==0){
         citer=iter; 
         citer++;
         refls->erase(*iter);
         //if(citer==children.end()){
         //}
         Gtk::TreeModel::Path path(citer);
         set_cursor(path);
         num_rows--;
         completion_signal.emit(BHITEMLIST_COMPLETION_REMOVE, item, &i_curr_row);
         if(num_rows==0){
            return 1;
         }
         return 0;
      }
      sprintf(cbuff, "%d", n);
      row[columns.quantity]=cbuff;
      grab_focus();
      refSelection->select(row);
      
      completion_signal.emit(BHITEMLIST_COMPLETION_DECEDIT, item, &i_curr_row);
   }
      break;
   
   case BHITEMLIST_ACTION_ADDTOLAST:
   {
      Gtk::TreeModel::Path path(row);
      buff=row[columns.quantity];
      n=atoi(buff.data());
      path.prev();
      iter=refls->get_iter(path);
      
      row=*iter;
      buff=row[columns.quantity];
      n+=atoi(buff.data());
      sprintf(cbuff, "%d", n);
      row[columns.quantity]=cbuff;      
      buff=row[columns.subtotal];
      d=atof(buff.data());
      sprintf(cbuff, "%0.2f", d*n);
      row[columns.total]=cbuff;
      iter++;
      refls->erase(*iter);
      refSelection->unselect_all();
   }
      return false;
   
   case BHITEMLIST_ACTION_CASHITEM:
   {
      row = *(refls->append());
      Gtk::TreeModel::Path path(row);
      row[columns.status]=BHITEMLIST_STATUS_CASHITEM;
      cell_col2->property_editable_set()=false;
      cell_col2->property_editable() = false;
      cell_col3->property_editable() = true;
      cell_col3->property_editable_set()=true;
      row[columns.plu]="-------------";
      row[columns.quantity]="1";
      row[columns.description]="Cash Item";
      grab_focus();
      set_cursor(path, *get_column(3), true);
      refSelection->select(row);
   }
      return false;
   
   case BHITEMLIST_ACTION_SELPRICE:
   {
      Gtk::TreeModel::Path path(row);
      row[columns.status]=BHITEMLIST_STATUS_PRICEEDIT;
      cell_col2->property_editable_set()=false;
      cell_col2->property_editable() = false;
      cell_col3->property_editable() = true;
      cell_col3->property_editable_set()=true;
      grab_focus();
      set_cursor(path, *get_column(3), true);
   }
      return false;
   
   case BHITEMLIST_ACTION_ITEMCLOSE:
   {
      Gtk::TreeModel::Path path(row);
      row[columns.status]=BHITEMLIST_STATUS_FIXED;
      row[columns.type]=BHITEMLIST_TYPE_UNKNOWN;
      cell_col3->property_editable() = false;
      cell_col3->property_editable_set()=false;
      
      buff=row[columns.quantity];
      n=atoi(buff.data());
      buff=row[columns.subtotal];
      d=atof(buff.data());
      sprintf(cbuff, "%0.2f", d*n);
      row[columns.total]=cbuff;
      refSelection->unselect_all();
   }
      break;
   
   case BHITEMLIST_ACTION_CLEAR:
   {
      Gtk::TreeModel::Path path(row);
      refSelection->unselect_all();
      //iter=refls->get_iter(path);
      if(iter){
         refls->erase(*iter);
      }
      else{
      }
   }
      break;
    
   case BHITEMLIST_ACTION_CANCELEDIT:
      break;
   
   case BHITEMLIST_ACTION_REMOVE:
   {
      // signal mfengine we have a remove from list...
      //fillitem((CSaleItem *) item);
      //(CSaleItem *) item->SetQuantity(0);
      
      citer=iter;
      citer++;
      refls->erase(*iter);
      Gtk::TreeModel::Path path(citer);
      set_cursor(path);
      ret=true;
   }
      break;
   
   
   /*
   case BHITEMLIST_ACTION_DECREMENT:
   {
      if(iter){
         buff=row[columns.quantity];
         n=atoi(buff.c_str());
         n--;
         if(n==0){
            // signal mfengine we have a remove from list...
            //fillitem((CSaleItem *) item);
            //(CSaleItem *) item->SetQuantity(0);
            citer=iter;
            citer++;
            refls->erase(*iter);
            Gtk::TreeModel::Path path(citer);
            set_cursor(path);
            ret=true;
         }
         sprintf(cbuff, "%d", n);
         row[columns.quantity]=cbuff;
         buff=row[columns.subtotal];
         d=atof(buff.data());
         sprintf(cbuff, "%0.2f", d*n);
         row[columns.total]=cbuff;
         //signal_saleitem_changed.emit(BHMF_CMD_TAXLIST, NULL);
         //fillitem((CSaleItem *) item);
      }
   }
      break;*/
   
   case BHITEMLIST_ACTION_QTYSET:
      if(item){
         sprintf(cbuff, "%d", *((int *) item));
         row[columns.quantity]=cbuff;
         buff=row[columns.subtotal];
         d=atof(buff.data());
         sprintf(cbuff, "%0.2f", d*n);
         row[columns.total]=cbuff;
         fillitem((CSaleItem *) item);
      }
      //row[columns.subtotal]=buff;
      //set_cursor(path, columns.quantity, true);
      break;
      
   case BHITEMLIST_ACTION_PAYBALANCE:
      total_row[columns.subtotal]="0.00";
      sprintf(cbuff, "%0.2f", due);
      row[columns.subtotal]=cbuff;
      curr_payitem.SetAmount(due);
      completion_signal.emit(BHITEMLIST_COMPLETION_TENDER, &curr_payitem, NULL);
      cell_col3->property_editable()=false;
      break;
   
   case BHITEMLIST_ACTION_CLEARTENDERTYPE:
   {
      Gtk::TreeModel::Path ppath;
      Gtk::TreeModel::iterator piter;
   
      ppath=curr_row;
      piter=refls->get_iter(ppath);
      if(*piter==total_row){
         return 1;
      }
      curr_row--;
      refls->erase(*piter);
      refSelection->unselect_all();
      // select prev row, see if it pay row, set curr_row
      ppath=curr_row;
      piter=refls->get_iter(ppath);
      refSelection->select(curr_row);
      if(*piter==total_row){
         return 1;
      }
   }
      return 0;
   
   case BHITEMLIST_ACTION_CLEARPAYAMOUNT:
   {
      Gtk::TreeModel::Path path(row);
      row[columns.subtotal]="";
      set_cursor(path, *get_column(3), true);
      refSelection->select(row);
   }
   
   case BHITEMLIST_ACTION_CLEARALLPAYMENT:
   {
      Gtk::TreeModel::Path ppath;
      Gtk::TreeModel::iterator piter;
   
      ppath=curr_row;
      piter=refls->get_iter(ppath);
      while(*piter!=total_row){
         refls->erase(*piter);
         ppath.prev();
         piter=refls->get_iter(ppath);
      }
      sprintf(cbuff, "%0.2f", total);
      buff=cbuff;
      total_row[columns.subtotal]=buff;
      curr_row=total_row;
      refSelection->select(total_row);
   }
      break;
   }
   
   return ret;
}

bool BhItemList::Navigation(BhNavigationType n)
{
   refSelection=get_selection();
   Gtk::TreeModel::iterator iter = refSelection->get_selected();
   Gtk::TreeModel::Children children = refls->children();
   bool bPreviter=false;
   //Gtk::TreeModel::Path     path = refls->get_path(iter);
   
   if(!refls){
      // bum ref ptr
      g_print("bum refptr for treestore\n");
   }
   
   if(!refSelection){
      // bum ref ptr
      g_print("bum refptr for selected\n");
   }

   if(!iter){
      if(children.empty()) return true;
      iter=children.end();
      iter--;
      bPreviter=true;
      if(!iter){
         g_print("No Iterator\n");
         return true;
      }
   }
   Gtk::TreeModel::Row  row=*iter;
   Gtk::TreeModel::Path path(row);

   switch(n){
   case BHNAV_TYPE_UP:
      if(bPreviter){
         refSelection->select(path);              // select the row
	   	scroll_to_row(path);           // scroll to make visible
		   i_curr_row = *(path.get_indices().begin());    // remember where we are
         curr_row=iter;
   		scroll(true);
      }
      else{
         if(iter != children.begin()){  //doesn't work 
            iter--;
         //if(path.to_string()!="0"){
            //set_cell_foreground_color(iter, DEFAULT);
	   	   path.prev();			                    // go to the prev row
            refSelection->select(path);              // select the row
   	   	scroll_to_row(path);           // scroll to make visible
	   	   i_curr_row = *(path.get_indices().begin());    // remember where we are
            curr_row=iter;
   		   scroll(true);
		      //set_cell_foreground_color(iter, SELECTED);
         }
	   }
      break;
   
   case BHNAV_TYPE_DOWN:
      if(!is_last_row(iter)){ // Are we about to hit the end?
   		//set_cell_foreground_color (iter, DEFAULT);  // restore color of cell
	   	path.next();
		   refSelection->select(path);
   		scroll_to_row(path);           // scroll to make visible
	   	i_curr_row = *(path.get_indices().begin());    // remember where we are
		   scroll(false);
         iter++;
         curr_row=iter;
	   	//set_cell_foreground_color(iter, SELECTED);
	   }
      else{
         iter=children.end();
         iter--;
         curr_row=iter;
         scroll(false);
         refSelection->unselect_all();
      }
      break;
      
   case BHNAV_TYPE_PGUP:
   case BHNAV_TYPE_PGDOWN:
      break;
   
   case BHNAV_TYPE_HOME:
   {
      iter=children.begin();
      Gtk::TreeModel::Row  hrow=*iter;
      Gtk::TreeModel::Path hpath(hrow);
      curr_row=iter;
      refSelection->select(hpath);
      scroll_to_row(hpath);           // scroll to make visible
	   i_curr_row = *(hpath.get_indices().begin());    // remember where we are
		scroll(false);
   }
      break;
   
   case BHNAV_TYPE_END:
      iter=children.end();
      iter--;
      curr_row=iter;
      scroll(false);
      refSelection->unselect_all();
      break;
   /*
   case BHNAV_TYPE_LEFT:
      if (m_cursor == RIGHT_CELL) {
		   set_cell_foreground_color (iter, DEFAULT);
		   m_cursor = LEFT_CELL;
		   set_cell_foreground_color (iter, SELECTED);
	   }
      break;
      
   case BHNAV_TYPE_RIGHT:
      if (m_cursor == RIGHT_CELL) {
		   set_cell_foreground_color (iter, DEFAULT);
		   m_cursor = LEFT_CELL;
		   set_cell_foreground_color (iter, SELECTED);
	   }
      break;
      */
   }
   return false;
}

bool BhItemList::is_last_row(Gtk::TreeModel::iterator& iter_)
{
	Gtk::TreeModel::iterator iter_next = iter_;
	Gtk::TreeModel::Children children = refls->children();
	iter_next++;
	return (iter_next == children.end());
}

void BhItemList::scroll(bool bUp)
{
   double foo;
   double pg_inc = scroll_win->get_vadjustment()->get_page_increment();
   double value = scroll_win->get_vadjustment()->get_value(); 
   double pg_sz = scroll_win->get_vadjustment()->get_page_size();

	if(bUp){
   	if(((i_curr_row+1) * row_height - value) < row_height){
	   	scroll_win->get_vadjustment()->set_value(value - pg_inc/2);
	   }
   }
   else{
	   double last_page = scroll_win->get_vadjustment()->get_upper() - pg_sz;
		
   	if(((i_curr_row+1) * row_height - value) > pg_sz){
	   	if((foo = value + pg_inc/2) > last_page) {
		   	scroll_win->get_vadjustment()->set_value(last_page);
		   }
		   else{
		   	scroll_win->get_vadjustment()->set_value(foo);
		   }
	   }
   }
}

}

}
