/*
bhkeyboard.h
Copyright (C) 2004  Al Kingsley

  This program is free software; you can redistribute it and/or modify
  it under the terms of the GNU General Public License as published by
  the Free Software Foundation; either version 2 of the License, or
  (at your option) any later version.
  
	This program is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU General Public License for more details.

	You should have received a copy of the GNU General Public License
	along with this program; if not, write to the Free Software
	Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

	Part of:
	BhPos, Copyright (C) 2001-2005 Al Kingsley
	BhPos comes with ABSOLUTELY NO WARRANTY. 
*/
#ifndef _BHKEYBOARD_H
#define _BHKEYBOARD_H

#include <gtkmm/main.h>
#include <gtkmm/table.h>
#include <gtkmm/button.h>
#include <gtkmm/image.h>
#include <gdkmm/color.h>
#include <gdk/gdkkeysyms.h>

namespace bhpos{

/**
 * \ingroup mflib
 * \@{	
 */

namespace widget{
/**
 * \defgroup keyboard Keyboard
 * \@{
 *
 * \ingroup bhwidget
 * \@{	
 */
   
typedef int (*NPCALLBACK)(GdkEventKey *);
/*! BhKeyboard 
   \brief A class to handle keyboard.
 */
class BhKeyboard : public Gtk::Table
{
private:
   Gtk::Image   *a;
   Gtk::Image   *b;
   Gtk::Image   *c;
   Gtk::Image   *d;
   Gtk::Image   *e;
   Gtk::Image   *f;
   Gtk::Image   *g;
   Gtk::Image   *h;
   Gtk::Image   *i;
   Gtk::Image   *j;
   Gtk::Image   *k;
   Gtk::Image   *l;
   Gtk::Image   *m;
   Gtk::Image   *n;
   Gtk::Image   *o;
   Gtk::Image   *p;
   Gtk::Image   *q;
   Gtk::Image   *r;
   Gtk::Image   *s;
   Gtk::Image   *t;
   Gtk::Image   *u;
   Gtk::Image   *v;
   Gtk::Image   *w;
   Gtk::Image   *x;
   Gtk::Image   *y;
   Gtk::Image   *z;
   Gtk::Image   *space;

   Gtk::Button *b_a;
   Gtk::Button *b_b;
   Gtk::Button *b_c;
   Gtk::Button *b_d;
   Gtk::Button *b_e;
   Gtk::Button *b_f;
   Gtk::Button *b_g;
   Gtk::Button *b_h;
   Gtk::Button *b_i;
   Gtk::Button *b_j;
   Gtk::Button *b_k;
   Gtk::Button *b_l;
   Gtk::Button *b_m;
   Gtk::Button *b_n;
   Gtk::Button *b_o;
   Gtk::Button *b_p;
   Gtk::Button *b_q;
   Gtk::Button *b_r;
   Gtk::Button *b_s;
   Gtk::Button *b_t;
   Gtk::Button *b_u;
   Gtk::Button *b_v;
   Gtk::Button *b_w;
   Gtk::Button *b_x;
   Gtk::Button *b_y;
   Gtk::Button *b_z;
   Gtk::Button *b_space;

protected:
   void on_a_clicked();
   void on_b_clicked();
   void on_c_clicked();
   void on_d_clicked();
   void on_e_clicked();
   void on_f_clicked();
   void on_g_clicked();
   void on_h_clicked();
   void on_i_clicked();
   void on_j_clicked();
   void on_k_clicked();
   void on_l_clicked();
   void on_m_clicked();
   void on_n_clicked();
   void on_o_clicked();
   void on_p_clicked();
   void on_q_clicked();
   void on_r_clicked();
   void on_s_clicked();
   void on_t_clicked();
   void on_u_clicked();
   void on_v_clicked();
   void on_w_clicked();
   void on_x_clicked();
   void on_y_clicked();
   void on_z_clicked();
   void on_space_clicked();
   
   NPCALLBACK  kf_callback;

public:
   BhKeyboard(Glib::ustring basedir, NPCALLBACK);
   ~BhKeyboard();
};
   
/* @} 
	@} */

}
/* @} */
}

#endif
