/*
bhmgbox.cpp
Copyright (C) 2004 Al Kingsley


  This program is free software; you can redistribute it and/or modify
  it under the terms of the GNU General Public License as published by
  the Free Software Foundation; either version 2 of the License, or
  (at your option) any later version.
  
	This program is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU General Public License for more details.

	You should have received a copy of the GNU General Public License
	along with this program; if not, write to the Free Software
	Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

	Don't write to me at: kingsley@bananahead.com 

	Part of:
	BhPos, Copyright (C) 2001-2005 Al Kingsley
	BhPos comes with ABSOLUTELY NO WARRANTY. 
*/

#include "config.h"
#include "bhintl.h"
#include "bhmsgbox.h"

namespace bhpos{

namespace widget{

bhmsgbox::bhmsgbox(unsigned int flags, char *title, char *pm, char *message) 
{
   int num=0;
   
   //Gtk::HButtonBox *hbuttonbox = manage(new class Gtk::HButtonBox(Gtk::BUTTONBOX_DEFAULT_STYLE, 30));
   switch(flags){
   case BHCONFIRMBOX_YESNO:
      yes=Gtk::manage(new class Gtk::Button(Gtk::StockID("gtk-yes")));
      no=Gtk::manage(new class Gtk::Button(Gtk::StockID("gtk-no")));
      add_action_widget(*yes, -6);
      add_action_widget(*no, -5);
	   num=2;
   	break;
   
   case BHCONFIRMBOX_OKCANCEL:
      yes = Gtk::manage(new class Gtk::Button(Gtk::StockID("gtk-ok")));
      no = Gtk::manage(new class Gtk::Button(Gtk::StockID("gtk-cancel")));
   	add_action_widget(*yes, -6);
      add_action_widget(*no, -5);
	   num=2;
   	break;
   	
   case BHCONFIRMBOX_OK:
   	yes = Gtk::manage(new class Gtk::Button(Gtk::StockID("gtk-ok")));
   	add_action_widget(*yes, -6);
   	num=1;
   	break;
		
	case BHCONFIRMBOX_CANCEL:
   	yes = Gtk::manage(new class Gtk::Button(Gtk::StockID("gtk-cancel")));
   	add_action_widget(*yes, -6);
   	num=1;
   	break;
   	
   case BHCONFIRMBOX_CLOSE:
   	yes = Gtk::manage(new class Gtk::Button(Gtk::StockID("gtk-close")));
   	add_action_widget(*yes, -6);
   	num=1;
   	break;
      
   case BHCONFIRMBOX_RETRYQUIT:
      yes = Gtk::manage(new class Gtk::Button(Gtk::StockID("gtk-refresh")));
      no = Gtk::manage(new class Gtk::Button(Gtk::StockID("gtk-close")));
   	add_action_widget(*yes, -6);
      add_action_widget(*no, -5);
   	num=2;
   	break;
      
   case BHCONFIRMBOX_CANCELRETRY:
      yes = Gtk::manage(new class Gtk::Button(Gtk::StockID("gtk-refresh")));
      no = Gtk::manage(new class Gtk::Button(Gtk::StockID("gtk-cancel")));
   	add_action_widget(*yes, -6);
      add_action_widget(*no, -5);
   	num=2;
   	break;
	}
   
   icon = manage(new class Gtk::Image(pm));
   label = manage(new class Gtk::Label(message));
   Gtk::HBox *hbox = manage(new class Gtk::HBox(false, 0));

   set_border_width(5);
   get_action_area()->property_layout_style().set_value(Gtk::BUTTONBOX_END);
   get_vbox()->set_homogeneous(false);
   get_vbox()->set_spacing(5);
   
   //icon->set_size(24, 24);
   icon->set_alignment(0.5, 0.5);
   icon->set_padding(10, 10);
   label->set_alignment(0.5, 0.5);
   label->set_padding(5, 5);
   hbox->set_border_width(5);
   hbox->pack_start(*icon);
   hbox->pack_start(*label, false, false, 0);
   get_vbox()->pack_start(*hbox);
   set_title(title);
   property_window_position().set_value(Gtk::WIN_POS_CENTER);
   set_resizable(false);
   property_destroy_with_parent().set_value(false);
   set_has_separator(true);
   
   set_modal(true);
   
   if(num>=1){
	   yes->show();
      yes->grab_focus();
	}
	if(num==2)
	   no->show();
	
   icon->show();
   label->show();
   hbox->show();

   show();
   
   if(num>=1)
      yes->signal_clicked().connect(sigc::mem_fun(*this, &bhmsgbox::on_yes_clicked));
	
	if(num==2)
   	no->signal_clicked().connect(sigc::mem_fun(*this, &bhmsgbox::on_no_clicked));
}

void bhmsgbox::on_yes_clicked()
{
	event_signal.emit(1);
	this->destroy_();
}

void bhmsgbox::on_no_clicked()
{
	event_signal.emit(0);
	this->destroy_();  
}

}

}
