/*
bhsmartbar.h 
Copyright (C) 2003  Al Kingsley

  This program is free software; you can redistribute it and/or modify
  it under the terms of the GNU General Public License as published by
  the Free Software Foundation; either version 2 of the License, or
  (at your option) any later version.
  
	This program is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU General Public License for more details.

	You should have received a copy of the GNU General Public License
	along with this program; if not, write to the Free Software
	Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

	Part of:
	BhPos, Copyright (C) 2001-2005 Al Kingsley
	BhPos comes with ABSOLUTELY NO WARRANTY. 
*/
#ifndef SMARTBAR_H
#define SMARTBAR_H

#include <gtkmm/button.h>
#include <gtkmm/buttonbox.h>
#include <gtkmm/toolbar.h>
#include <gtkmm/image.h>
#include <glibmm/ustring.h>
#include <gdk/gdkkeysyms.h>

namespace bhpos{

/**
 * \ingroup mflib
 * \@{	
 */
   
namespace widget{

/**
 * \defgroup smartbar Smart Bar
 * \@{
 *
 * \ingroup bhwidget
 * \@{	
 */

enum BhSmartBarType{
   BHSMARTBARTYPE_LABEL,
   BHSMARTBARTYPE_IMAGE,
   BHSMARTBARTYPE_LABELIMAGE,
   BHSMARTBARTYPE_LABELIMAGEKEY,
};

enum BhSmartButton{
   BHSB_EXIT,
   BHSB_LOGOUT,
   BHSB_CANCEL,
   BHSB_DONE,
   BHSB_CLEAR,
   BHSB_QUANTITY,
   BHSB_REQUEST,
   BHSB_SALEPRICE,
   BHSB_TRANSCYCLE,
   BHSB_TOTAL,
   BHSB_CASH,
   BHSB_CHEQUE,
   BHSB_CREDIT,
   BHSB_CHARGE,
   BHSB_COMMIT,
   BHSB_ALLAMOUNT,
   BHSB_RETURN,
   BHSB_PLULOOKUP,
   BHSB_REMOVE,
   BHSB_PAYIN,
   BHSB_PAYOUT,
   BHSB_DISCOUNT,
   BHSB_RENTAL,
   BHSB_DELIVERY,
   BHSB_EPHEMERAL,
   BHSB_LAYBY,
   BHSB_NOSALE,
   BHSB_CASHITEM,
   BHSB_NEWCUST,
   BHSB_FINDCUST,
   BHSB_INCREMENT,
   BHSB_DECREMENT,
   BHSB_QTYSET,
   BHSB_DELETE,
   BHSB_RETURNTRANS,
   BHSB_RETURNITEM
};

typedef struct tagskaction{
   unsigned int k;
   int  kl;
   int  m;
}skaction;

typedef struct tagbuttonitem{
   char label[16];
   Gtk::Image *pm;
}buttonitem;

typedef int (*SBCALLBACK)(GdkEventKey *);
/*! \brief A class to handle the smart bar.*/
class BhSmartBar : public Gtk::HButtonBox //public Gtk::Toolbar
{  
private:
   BhSmartBarType    type;
   //Gtk::ToolbarStyle style;
   bool              bCallback;
   SBCALLBACK        kf_callback;

   void on_button_clicked(BhSmartButton);

protected:
   Gtk::Image *AddTextImage(char *imagefile);
   sigc::signal<void, BhSmartButton, GdkEventKey *> keypress_signal;

public:
   BhSmartBar(Gtk::ButtonBoxStyle orientation, BhSmartBarType type, SBCALLBACK);
   BhSmartBar(Gtk::ButtonBoxStyle orientation, BhSmartBarType type);

   //BhSmartBar(Gtk::Orientation orientation, BhSmartBarType type, SBCALLBACK);
   //BhSmartBar(Gtk::Orientation orientation, BhSmartBarType type);
   ~BhSmartBar();
   bool Push(char *, char *, unsigned int *k, BhSmartButton, int m, char *key);
   //bool Push(char *, char *, char *, char *, unsigned int *k, BhSmartButton, int m);
   void Insert(int, char *, char *, unsigned int *k, BhSmartButton, int m);
   void Remove(int);
   sigc::signal<void, BhSmartButton, GdkEventKey *> signal_keypress(){ return keypress_signal; }
};

/* @} 
	@} */

}

/* @} */

}

#endif
