/* bhstatus.cpp
 *
 * Copyright (C) 2004 Al Kingsley
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License as
 * published by the Free Software Foundation; either version 2 of the
 * License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * General Public License for more details.
 *
 * You should have received a copy of the GNU General Public
 * License along with this program; if not, write to the
 * Free Software Foundation, Inc., 59 Temple Place - Suite 330,
 * Boston, MA 02111-1307, USA.
 */
#include "config.h"
#include "bhtransdetail.h"
#include "bhintl.h"

namespace bhpos{

namespace widget{

BhTransDetail::BhTransDetail(BaseObjectType* cobject) : Gtk::VBox(cobject)
{
   Gdk::Color col;
   
   number = Gtk::manage(new class Gtk::Entry());
   subtotal = Gtk::manage(new class Gtk::Entry());
   tax = Gtk::manage(new class Gtk::Entry());
   total = Gtk::manage(new class Gtk::Entry());
   tendered = Gtk::manage(new class Gtk::Entry());
   change = Gtk::manage(new class Gtk::Entry());
      
   label1 = Gtk::manage(new class Gtk::Label(_("Transaction Number")));
   label2 = Gtk::manage(new class Gtk::Label(_("Sub Total")));
   label3 = Gtk::manage(new class Gtk::Label(_("Tax")));
   label4 = Gtk::manage(new class Gtk::Label(_("Total")));
   label5 = Gtk::manage(new class Gtk::Label(_("Tendered")));
   label6 = Gtk::manage(new class Gtk::Label(_("Change")));
   
   label1->set_alignment(0, 1.0);
   label1->set_padding(0,0);
   label1->set_justify(Gtk::JUSTIFY_LEFT);
   label1->set_line_wrap(false);
   label1->set_use_markup(false);
   label1->set_selectable(false);
   number->set_size_request(64,-1);
   number->set_flags(Gtk::CAN_FOCUS);
   number->set_visibility(true);
   number->set_editable(false);
   number->set_max_length(0);
   number->set_text(_(""));
   number->set_has_frame(true);
   number->set_activates_default(false);
   //number->set_width_chars(16);
   number->property_can_focus ()=false;
   number->property_sensitive()=false;
   
   label2->set_alignment(0,1.0);
   label2->set_padding(0,0);
   label2->set_justify(Gtk::JUSTIFY_LEFT);
   label2->set_line_wrap(false);
   label2->set_use_markup(false);
   label2->set_selectable(false);
   subtotal->set_size_request(64,-1);
   subtotal->set_flags(Gtk::CAN_FOCUS);
   subtotal->set_visibility(true);
   subtotal->set_editable(false);
   subtotal->set_max_length(0);
   subtotal->set_text(_(""));
   subtotal->set_has_frame(true);
   subtotal->set_activates_default(false);
   subtotal->set_width_chars(16);
   subtotal->property_can_focus ()=false;
   subtotal->property_sensitive()=false;
   
   label3->set_alignment(0,1.0);
   label3->set_padding(0,0);
   label3->set_justify(Gtk::JUSTIFY_LEFT);
   label3->set_line_wrap(false);
   label3->set_use_markup(false);
   label3->set_selectable(false);
   tax->set_size_request(64,-1);
   tax->set_flags(Gtk::CAN_FOCUS);
   tax->set_visibility(true);
   tax->set_editable(false);
   tax->set_max_length(0);
   tax->set_text(_(""));
   tax->set_has_frame(true);
   tax->set_activates_default(false);
   tax->set_width_chars(16);
   total->property_can_focus ()=false;
   total->property_sensitive()=false;
   
   label4->set_alignment(0,1.0);
   label4->set_padding(0,0);
   label4->set_justify(Gtk::JUSTIFY_LEFT);
   label4->set_line_wrap(false);
   label4->set_use_markup(false);
   label4->set_selectable(false);
   total->set_size_request(64,-1);
   total->set_flags(Gtk::CAN_FOCUS);
   total->set_visibility(true);
   total->set_editable(false);
   total->set_max_length(0);
   total->set_text(_(""));
   total->set_has_frame(true);
   total->set_activates_default(false);
   total->set_width_chars(16);
   total->property_can_focus ()=false;
   total->property_sensitive()=false;
   
   label5->set_alignment(0,1.0);
   label5->set_padding(0,0);
   label5->set_justify(Gtk::JUSTIFY_LEFT);
   label5->set_line_wrap(false);
   label5->set_use_markup(false);
   label5->set_selectable(false);
   tendered->set_size_request(64,-1);
   tendered->set_flags(Gtk::CAN_FOCUS);
   tendered->set_visibility(true);
   tendered->set_editable(false);
   tendered->set_max_length(0);
   tendered->set_text(_(""));
   tendered->set_has_frame(true);
   tendered->set_activates_default(false);
   tendered->set_width_chars(16);
   tendered->property_can_focus ()=false;
   tendered->property_sensitive()=false;
   
   label6->set_alignment(0,1.0);
   label6->set_padding(0,0);
   label6->set_justify(Gtk::JUSTIFY_LEFT);
   label6->set_line_wrap(false);
   label6->set_use_markup(false);
   label6->set_selectable(false);
   change->set_size_request(64,-1);
   change->set_flags(Gtk::CAN_FOCUS);
   change->set_visibility(true);
   change->set_editable(false);
   change->set_max_length(0);
   change->set_text(_(""));
   change->set_has_frame(true);
   change->set_activates_default(false);
   change->set_width_chars(16);
   change->property_can_focus ()=false;
   change->property_sensitive()=false;
   
   col.set_rgb(0xFFFF, 0xFFFF, 0xFFFF);
   number->modify_bg(Gtk::STATE_INSENSITIVE, col);
   subtotal->modify_bg(Gtk::STATE_INSENSITIVE, col);
   tax->modify_bg(Gtk::STATE_INSENSITIVE, col);
   total->modify_bg(Gtk::STATE_INSENSITIVE, col);
   tendered->modify_bg(Gtk::STATE_INSENSITIVE, col);
   change->modify_bg(Gtk::STATE_INSENSITIVE, col);
   
   col.set_rgb(0, 0, 0);
   tax->modify_text(Gtk::STATE_INSENSITIVE, col);
   total->modify_text(Gtk::STATE_INSENSITIVE, col);
   tendered->modify_text(Gtk::STATE_INSENSITIVE, col);
   change->modify_text(Gtk::STATE_INSENSITIVE, col);
   
   pack_start(*label1, Gtk::PACK_SHRINK, 0);
   pack_start(*number, Gtk::PACK_SHRINK, 0);
   pack_start(*label2, Gtk::PACK_SHRINK, 0);
   pack_start(*subtotal, Gtk::PACK_SHRINK, 0);
   pack_start(*label3, Gtk::PACK_SHRINK, 0);
   pack_start(*tax, Gtk::PACK_SHRINK, 0);
   pack_start(*label4, Gtk::PACK_SHRINK, 0);
   pack_start(*total, Gtk::PACK_SHRINK, 0);
   pack_start(*label5, Gtk::PACK_SHRINK, 0);
   pack_start(*tendered, Gtk::PACK_SHRINK, 0);
   pack_start(*label6, Gtk::PACK_SHRINK, 0);
   pack_start(*change, Gtk::PACK_SHRINK, 0);
}

BhTransDetail::BhTransDetail() : Gtk::VBox(true, 3)
{
   Gdk::Color col;
   
   number = Gtk::manage(new class Gtk::Entry());
   subtotal = Gtk::manage(new class Gtk::Entry());
   tax = Gtk::manage(new class Gtk::Entry());
   total = Gtk::manage(new class Gtk::Entry());
   tendered = Gtk::manage(new class Gtk::Entry());
   change = Gtk::manage(new class Gtk::Entry());
      
   label1 = Gtk::manage(new class Gtk::Label(_("Transaction Number")));
   label2 = Gtk::manage(new class Gtk::Label(_("Sub Total")));
   label3 = Gtk::manage(new class Gtk::Label(_("Tax")));
   label4 = Gtk::manage(new class Gtk::Label(_("Total")));
   label5 = Gtk::manage(new class Gtk::Label(_("Tendered")));
   label6 = Gtk::manage(new class Gtk::Label(_("Change")));
   
   label1->set_alignment(0,1.0);
   label1->set_padding(0,0);
   label1->set_justify(Gtk::JUSTIFY_LEFT);
   label1->set_line_wrap(false);
   label1->set_use_markup(false);
   label1->set_selectable(false);
   number->set_size_request(64,-1);
   number->set_flags(Gtk::CAN_FOCUS);
   number->set_visibility(true);
   number->set_editable(false);
   number->set_max_length(0);
   number->set_text(_(""));
   number->set_has_frame(true);
   number->set_activates_default(false);
   //number->set_width_chars(16);
   number->property_can_focus ()=false;
   //number->property_sensitive()=false;
   
   label2->set_alignment(0,1.0);
   label2->set_padding(0,0);
   label2->set_justify(Gtk::JUSTIFY_LEFT);
   label2->set_line_wrap(false);
   label2->set_use_markup(false);
   label2->set_selectable(false);
   subtotal->set_size_request(64,-1);
   subtotal->set_flags(Gtk::CAN_FOCUS);
   subtotal->set_visibility(true);
   subtotal->set_editable(false);
   subtotal->set_max_length(0);
   subtotal->set_text(_(""));
   subtotal->set_has_frame(true);
   subtotal->set_activates_default(false);
   subtotal->set_width_chars(16);
   subtotal->property_can_focus ()=false;
   //subtotal->property_sensitive()=false;
   
   label3->set_alignment(0,1.0);
   label3->set_padding(0,0);
   label3->set_justify(Gtk::JUSTIFY_LEFT);
   label3->set_line_wrap(false);
   label3->set_use_markup(false);
   label3->set_selectable(false);
   tax->set_size_request(64,-1);
   tax->set_flags(Gtk::CAN_FOCUS);
   tax->set_visibility(true);
   tax->set_editable(false);
   tax->set_max_length(0);
   tax->set_text(_(""));
   tax->set_has_frame(true);
   tax->set_activates_default(false);
   tax->set_width_chars(16);
   tax->property_can_focus ()=false;
   //tax->property_sensitive()=false;
   
   label4->set_alignment(0,1.0);
   label4->set_padding(0,0);
   label4->set_justify(Gtk::JUSTIFY_LEFT);
   label4->set_line_wrap(false);
   label4->set_use_markup(false);
   label4->set_selectable(false);
   total->set_size_request(64,-1);
   total->set_flags(Gtk::CAN_FOCUS);
   total->set_visibility(true);
   total->set_editable(false);
   total->set_max_length(0);
   total->set_text(_(""));
   total->set_has_frame(true);
   total->set_activates_default(false);
   total->set_width_chars(16);
   total->property_can_focus ()=false;
   //total->property_sensitive()=false;
   
   label5->set_alignment(0,1.0);
   label5->set_padding(0,0);
   label5->set_justify(Gtk::JUSTIFY_LEFT);
   label5->set_line_wrap(false);
   label5->set_use_markup(false);
   label5->set_selectable(false);
   tendered->set_size_request(64,-1);
   tendered->set_flags(Gtk::CAN_FOCUS);
   tendered->set_visibility(true);
   tendered->set_editable(false);
   tendered->set_max_length(0);
   tendered->set_text(_(""));
   tendered->set_has_frame(true);
   tendered->set_activates_default(false);
   tendered->set_width_chars(16);
   tendered->property_can_focus ()=false;
   //tendered->property_sensitive()=false;
   
   label6->set_alignment(0,1.0);
   label6->set_padding(0,0);
   label6->set_justify(Gtk::JUSTIFY_LEFT);
   label6->set_line_wrap(false);
   label6->set_use_markup(false);
   label6->set_selectable(false);
   change->set_size_request(64,-1);
   change->set_flags(Gtk::CAN_FOCUS);
   change->set_visibility(true);
   change->set_editable(false);
   change->set_max_length(0);
   change->set_text(_(""));
   change->set_has_frame(true);
   change->set_activates_default(false);
   change->set_width_chars(16);
   change->property_can_focus ()=false;
   //change->property_sensitive()=false;
   /*
   col.set_rgb(0xFFFFFF, 0xFFFFFF, 0xFFFFFF);
   number->modify_bg(Gtk::STATE_INSENSITIVE, col);
   subtotal->modify_bg(Gtk::STATE_INSENSITIVE, col);
   tax->modify_bg(Gtk::STATE_INSENSITIVE, col);
   total->modify_bg(Gtk::STATE_INSENSITIVE, col);
   tendered->modify_bg(Gtk::STATE_INSENSITIVE, col);
   change->modify_bg(Gtk::STATE_INSENSITIVE, col);
   
   col.set_rgb(0, 0, 0);
   tax->modify_text(Gtk::STATE_INSENSITIVE, col);
   total->modify_text(Gtk::STATE_INSENSITIVE, col);
   tendered->modify_text(Gtk::STATE_INSENSITIVE, col);
   change->modify_text(Gtk::STATE_INSENSITIVE, col);
   */
   pack_start(*label1, true, true, 0);
   pack_start(*number, true, true, 0);
   pack_start(*label2, true, true, 0);
   pack_start(*subtotal, true, true, 0);
   pack_start(*label3, true, true, 0);
   pack_start(*tax, true, true, 0);
   pack_start(*label4, true, true, 0);
   pack_start(*total, true, true, 0);
   pack_start(*label5, true, true, 0);
   pack_start(*tendered, true, true, 0);
   pack_start(*label6, true, true, 0);
   pack_start(*change, true, true, 0);
   /*
   pack_start(*label1, Gtk::PACK_SHRINK, 0);
   pack_start(*number, Gtk::PACK_SHRINK, 0);
   pack_start(*label2, Gtk::PACK_SHRINK, 0);
   pack_start(*subtotal, Gtk::PACK_SHRINK, 0);
   pack_start(*label3, Gtk::PACK_SHRINK, 0);
   pack_start(*tax, Gtk::PACK_SHRINK, 0);
   pack_start(*label4, Gtk::PACK_SHRINK, 0);
   pack_start(*total, Gtk::PACK_SHRINK, 0);
   pack_start(*label5, Gtk::PACK_SHRINK, 0);
   pack_start(*tendered, Gtk::PACK_SHRINK, 0);
   pack_start(*label6, Gtk::PACK_SHRINK, 0);
   pack_start(*change, Gtk::PACK_SHRINK, 0);
   */
}

BhTransDetail::BhTransDetail(bool bn, Glib::ustring basedir, NPCALLBACK np) : Gtk::VBox(true, 3)
{
   Gdk::Color col;
   
   if(bn){
      bHasNumPad=true;
   }
   number = Gtk::manage(new class Gtk::Entry());
   subtotal = Gtk::manage(new class Gtk::Entry());
   tax = Gtk::manage(new class Gtk::Entry());
   total = Gtk::manage(new class Gtk::Entry());
   tendered = Gtk::manage(new class Gtk::Entry());
   change = Gtk::manage(new class Gtk::Entry());
      
   label1 = Gtk::manage(new class Gtk::Label(_("Transaction Number")));
   label2 = Gtk::manage(new class Gtk::Label(_("Sub Total")));
   label3 = Gtk::manage(new class Gtk::Label(_("Tax")));
   label4 = Gtk::manage(new class Gtk::Label(_("Total")));
   label5 = Gtk::manage(new class Gtk::Label(_("Tendered")));
   label6 = Gtk::manage(new class Gtk::Label(_("Change")));
   
   label1->set_alignment(0,0.5);
   label1->set_padding(0,0);
   label1->set_justify(Gtk::JUSTIFY_LEFT);
   label1->set_line_wrap(false);
   label1->set_use_markup(false);
   label1->set_selectable(false);
   number->set_size_request(64,-1);
   number->set_flags(Gtk::CAN_FOCUS);
   number->set_visibility(true);
   number->set_editable(false);
   number->set_max_length(0);
   number->set_text(_(""));
   number->set_has_frame(true);
   number->set_activates_default(false);
   //number->set_width_chars(16);
   number->property_can_focus ()=false;
   number->property_sensitive()=false;
   
   label2->set_alignment(0,0.5);
   label2->set_padding(0,0);
   label2->set_justify(Gtk::JUSTIFY_LEFT);
   label2->set_line_wrap(false);
   label2->set_use_markup(false);
   label2->set_selectable(false);
   subtotal->set_size_request(64,-1);
   subtotal->set_flags(Gtk::CAN_FOCUS);
   subtotal->set_visibility(true);
   subtotal->set_editable(false);
   subtotal->set_max_length(0);
   subtotal->set_text(_(""));
   subtotal->set_has_frame(true);
   subtotal->set_activates_default(false);
   subtotal->set_width_chars(16);
   subtotal->property_can_focus ()=false;
   subtotal->property_sensitive()=false;
   
   label3->set_alignment(0,0.5);
   label3->set_padding(0,0);
   label3->set_justify(Gtk::JUSTIFY_LEFT);
   label3->set_line_wrap(false);
   label3->set_use_markup(false);
   label3->set_selectable(false);
   tax->set_size_request(64,-1);
   tax->set_flags(Gtk::CAN_FOCUS);
   tax->set_visibility(true);
   tax->set_editable(false);
   tax->set_max_length(0);
   tax->set_text(_(""));
   tax->set_has_frame(true);
   tax->set_activates_default(false);
   tax->set_width_chars(16);
   total->property_can_focus ()=false;
   total->property_sensitive()=false;
   
   label4->set_alignment(0,0.5);
   label4->set_padding(0,0);
   label4->set_justify(Gtk::JUSTIFY_LEFT);
   label4->set_line_wrap(false);
   label4->set_use_markup(false);
   label4->set_selectable(false);
   total->set_size_request(64,-1);
   total->set_flags(Gtk::CAN_FOCUS);
   total->set_visibility(true);
   total->set_editable(false);
   total->set_max_length(0);
   total->set_text(_(""));
   total->set_has_frame(true);
   total->set_activates_default(false);
   total->set_width_chars(16);
   total->property_can_focus ()=false;
   total->property_sensitive()=false;
   
   label5->set_alignment(0,0.5);
   label5->set_padding(0,0);
   label5->set_justify(Gtk::JUSTIFY_LEFT);
   label5->set_line_wrap(false);
   label5->set_use_markup(false);
   label5->set_selectable(false);
   tendered->set_size_request(64,-1);
   tendered->set_flags(Gtk::CAN_FOCUS);
   tendered->set_visibility(true);
   tendered->set_editable(false);
   tendered->set_max_length(0);
   tendered->set_text(_(""));
   tendered->set_has_frame(true);
   tendered->set_activates_default(false);
   tendered->set_width_chars(16);
   tendered->property_can_focus ()=false;
   tendered->property_sensitive()=false;
   
   label6->set_alignment(0,0.5);
   label6->set_padding(0,0);
   label6->set_justify(Gtk::JUSTIFY_LEFT);
   label6->set_line_wrap(false);
   label6->set_use_markup(false);
   label6->set_selectable(false);
   change->set_size_request(64,-1);
   change->set_flags(Gtk::CAN_FOCUS);
   change->set_visibility(true);
   change->set_editable(false);
   change->set_max_length(0);
   change->set_text(_(""));
   change->set_has_frame(true);
   change->set_activates_default(false);
   change->set_width_chars(16);
   change->property_can_focus ()=false;
   change->property_sensitive()=false;
   
   col.set_rgb(0xFFFF, 0xFFFF, 0xFFFF);
   number->modify_bg(Gtk::STATE_INSENSITIVE, col);
   subtotal->modify_bg(Gtk::STATE_INSENSITIVE, col);
   tax->modify_bg(Gtk::STATE_INSENSITIVE, col);
   total->modify_bg(Gtk::STATE_INSENSITIVE, col);
   tendered->modify_bg(Gtk::STATE_INSENSITIVE, col);
   change->modify_bg(Gtk::STATE_INSENSITIVE, col);
   
   col.set_rgb(0, 0, 0);
   tax->modify_text(Gtk::STATE_INSENSITIVE, col);
   total->modify_text(Gtk::STATE_INSENSITIVE, col);
   tendered->modify_text(Gtk::STATE_INSENSITIVE, col);
   change->modify_text(Gtk::STATE_INSENSITIVE, col);
   
   pack_start(*label1, Gtk::PACK_SHRINK, 0);
   pack_start(*number, Gtk::PACK_SHRINK, 0);
   pack_start(*label2, Gtk::PACK_SHRINK, 0);
   pack_start(*subtotal, Gtk::PACK_SHRINK, 0);
   pack_start(*label3, Gtk::PACK_SHRINK, 0);
   pack_start(*tax, Gtk::PACK_SHRINK, 0);
   pack_start(*label4, Gtk::PACK_SHRINK, 0);
   pack_start(*total, Gtk::PACK_SHRINK, 0);
   pack_start(*label5, Gtk::PACK_SHRINK, 0);
   pack_start(*tendered, Gtk::PACK_SHRINK, 0);
   pack_start(*label6, Gtk::PACK_SHRINK, 0);
   pack_start(*change, Gtk::PACK_SHRINK, 0);
   
   if(bn){
      numpad=Gtk::manage(new class BhNumPad(basedir, np));
      pack_start(*numpad, Gtk::PACK_SHRINK, 0);
   }
}

BhTransDetail::BhTransDetail(bool bn, Glib::ustring basedir) : Gtk::VBox(false, 10)
{
   Gdk::Color col;
   
   if(bn){
      bHasNumPad=true;
   }
   number = Gtk::manage(new class Gtk::Entry());
   subtotal = Gtk::manage(new class Gtk::Entry());
   tax = Gtk::manage(new class Gtk::Entry());
   total = Gtk::manage(new class Gtk::Entry());
   tendered = Gtk::manage(new class Gtk::Entry());
   change = Gtk::manage(new class Gtk::Entry());
      
   label1 = Gtk::manage(new class Gtk::Label(_("Transaction Number")));
   label2 = Gtk::manage(new class Gtk::Label(_("Sub Total")));
   label3 = Gtk::manage(new class Gtk::Label(_("Tax")));
   label4 = Gtk::manage(new class Gtk::Label(_("Total")));
   label5 = Gtk::manage(new class Gtk::Label(_("Tendered")));
   label6 = Gtk::manage(new class Gtk::Label(_("Change")));
   
   label1->set_alignment(0,0.5);
   label1->set_padding(0,0);
   label1->set_justify(Gtk::JUSTIFY_LEFT);
   label1->set_line_wrap(false);
   label1->set_use_markup(false);
   label1->set_selectable(false);
   number->set_size_request(64,-1);
   number->set_flags(Gtk::CAN_FOCUS);
   number->set_visibility(true);
   number->set_editable(false);
   number->set_max_length(0);
   number->set_text(_(""));
   number->set_has_frame(true);
   number->set_activates_default(false);
   //number->set_width_chars(16);
   number->property_can_focus ()=false;
   number->property_sensitive()=false;
   
   label2->set_alignment(0,0.5);
   label2->set_padding(0,0);
   label2->set_justify(Gtk::JUSTIFY_LEFT);
   label2->set_line_wrap(false);
   label2->set_use_markup(false);
   label2->set_selectable(false);
   subtotal->set_size_request(64,-1);
   subtotal->set_flags(Gtk::CAN_FOCUS);
   subtotal->set_visibility(true);
   subtotal->set_editable(false);
   subtotal->set_max_length(0);
   subtotal->set_text(_(""));
   subtotal->set_has_frame(true);
   subtotal->set_activates_default(false);
   subtotal->set_width_chars(16);
   subtotal->property_can_focus ()=false;
   subtotal->property_sensitive()=false;
   
   label3->set_alignment(0,0.5);
   label3->set_padding(0,0);
   label3->set_justify(Gtk::JUSTIFY_LEFT);
   label3->set_line_wrap(false);
   label3->set_use_markup(false);
   label3->set_selectable(false);
   tax->set_size_request(64,-1);
   tax->set_flags(Gtk::CAN_FOCUS);
   tax->set_visibility(true);
   tax->set_editable(false);
   tax->set_max_length(0);
   tax->set_text(_(""));
   tax->set_has_frame(true);
   tax->set_activates_default(false);
   tax->set_width_chars(16);
   total->property_can_focus ()=false;
   total->property_sensitive()=false;
   
   label4->set_alignment(0,0.5);
   label4->set_padding(0,0);
   label4->set_justify(Gtk::JUSTIFY_LEFT);
   label4->set_line_wrap(false);
   label4->set_use_markup(false);
   label4->set_selectable(false);
   total->set_size_request(64,-1);
   total->set_flags(Gtk::CAN_FOCUS);
   total->set_visibility(true);
   total->set_editable(false);
   total->set_max_length(0);
   total->set_text(_(""));
   total->set_has_frame(true);
   total->set_activates_default(false);
   total->set_width_chars(16);
   total->property_can_focus ()=false;
   total->property_sensitive()=false;
   
   label5->set_alignment(0,0.5);
   label5->set_padding(0,0);
   label5->set_justify(Gtk::JUSTIFY_LEFT);
   label5->set_line_wrap(false);
   label5->set_use_markup(false);
   label5->set_selectable(false);
   tendered->set_size_request(64,-1);
   tendered->set_flags(Gtk::CAN_FOCUS);
   tendered->set_visibility(true);
   tendered->set_editable(false);
   tendered->set_max_length(0);
   tendered->set_text(_(""));
   tendered->set_has_frame(true);
   tendered->set_activates_default(false);
   tendered->set_width_chars(16);
   tendered->property_can_focus ()=false;
   tendered->property_sensitive()=false;
   
   label6->set_alignment(0,0.5);
   label6->set_padding(0,0);
   label6->set_justify(Gtk::JUSTIFY_LEFT);
   label6->set_line_wrap(false);
   label6->set_use_markup(false);
   label6->set_selectable(false);
   change->set_size_request(64,-1);
   change->set_flags(Gtk::CAN_FOCUS);
   change->set_visibility(true);
   change->set_editable(false);
   change->set_max_length(0);
   change->set_text(_(""));
   change->set_has_frame(true);
   change->set_activates_default(false);
   change->set_width_chars(16);
   change->property_can_focus ()=false;
   change->property_sensitive()=false;
   
   col.set_rgb(0xFFFF, 0xFFFF, 0xFFFF);
   number->modify_bg(Gtk::STATE_INSENSITIVE, col);
   subtotal->modify_bg(Gtk::STATE_INSENSITIVE, col);
   tax->modify_bg(Gtk::STATE_INSENSITIVE, col);
   total->modify_bg(Gtk::STATE_INSENSITIVE, col);
   tendered->modify_bg(Gtk::STATE_INSENSITIVE, col);
   change->modify_bg(Gtk::STATE_INSENSITIVE, col);
   
   col.set_rgb(0, 0, 0);
   tax->modify_text(Gtk::STATE_INSENSITIVE, col);
   total->modify_text(Gtk::STATE_INSENSITIVE, col);
   tendered->modify_text(Gtk::STATE_INSENSITIVE, col);
   change->modify_text(Gtk::STATE_INSENSITIVE, col);
   
   pack_start(*label1, Gtk::PACK_SHRINK, 0);
   pack_start(*number, Gtk::PACK_SHRINK, 0);
   pack_start(*label2, Gtk::PACK_SHRINK, 0);
   pack_start(*subtotal, Gtk::PACK_SHRINK, 0);
   pack_start(*label3, Gtk::PACK_SHRINK, 0);
   pack_start(*tax, Gtk::PACK_SHRINK, 0);
   pack_start(*label4, Gtk::PACK_SHRINK, 0);
   pack_start(*total, Gtk::PACK_SHRINK, 0);
   pack_start(*label5, Gtk::PACK_SHRINK, 0);
   pack_start(*tendered, Gtk::PACK_SHRINK, 0);
   pack_start(*label6, Gtk::PACK_SHRINK, 0);
   pack_start(*change, Gtk::PACK_SHRINK, 0);
   
   if(bn){
      numpad=Gtk::manage(new class BhNumPad(basedir));
      if(numpad)
         pack_start(*numpad, Gtk::PACK_SHRINK, 0);
   }
}
  
BhTransDetail::~BhTransDetail()
{
}

void BhTransDetail::Clear()
{
   number->set_text("");
   subtotal->set_text("");
   tax->set_text("");
   total->set_text("");
   tendered->set_text("");
   change->set_text("");
}

void BhTransDetail::SetText(BhTransDetailItem b, Glib::ustring buff)
{
	switch(b){
	case BHTRANDETAIL_NUMBER:
		number->set_text(buff);
		break;
		
	case BHTRANDETAIL_SUBTOTAL:
		subtotal->set_text(buff);
		break;
	
	case BHTRANDETAIL_TAX:
		tax->set_text(buff);
		break;
		
	case BHTRANDETAIL_TOTAL:
		total->set_text(buff);
		break;

   case BHTRANDETAIL_TENDERED:
      tendered->set_text(buff);
		break;
   
   case BHTRANDETAIL_CHANGE:
      change->set_text(buff);
		break;
	}
}

void BhTransDetail::SetColour(BhTransDetailItem i, Gtk::StateType t, Gdk::Color col)
{
   switch(i){
   case BHTRANDETAIL_NUMBER:
		number->modify_text(t, col);
		break;
		
	case BHTRANDETAIL_SUBTOTAL:
		subtotal->modify_text(t, col);
		break;
	
	case BHTRANDETAIL_TAX:
		tax->modify_text(t, col);
		break;
		
	case BHTRANDETAIL_TOTAL:
		total->modify_text(t, col);
		break;

   case BHTRANDETAIL_TENDERED:
      tendered->modify_text(t, col);
		break;
   
   case BHTRANDETAIL_CHANGE:
      change->modify_text(t, col);
		break;
	}
}

}

}
