/* bhtransdetail.h
 *
 * Copyright (C) 2001-2004 Al Kingsley
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License as
 * published by the Free Software Foundation; either version 2 of the
 * License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * General Public License for more details.
 *
 * You should have received a copy of the GNU General Public
 * License along with this program; if not, write to the
 * Free Software Foundation, Inc., 59 Temple Place - Suite 330,
 * Boston, MA 02111-1307, USA.
 * Part of:
 *    BhPos, Copyright (C) 2001-2005 Al Kingsley
 *    BhPos comes with ABSOLUTELY NO WARRANTY.
 */

#ifndef BHTRANSDETAIL_H
#define BHTRANSDETAIL_H

#include <gtkmm/box.h>
#include <gtkmm/label.h>
#include <gtkmm/entry.h>
#include "bhentry.h"
#include "bhnumpad.h"

namespace bhpos{

/**
 * @ingroup mflib
 * @{	
 */
   
namespace widget{

/**
 * \defgroup bhtransdetail Transaction Details
 * @{
 *
 * \ingroup bhwidget
 * @{	
 */

enum BhTransDetailItem{
   BHTRANDETAIL_NUMBER,
   BHTRANDETAIL_SUBTOTAL,
   BHTRANDETAIL_TAX,
   BHTRANDETAIL_TOTAL,
   BHTRANDETAIL_TENDERED,
   BHTRANDETAIL_CHANGE
};   

/*! BhTransDetail 
   brief A class to transaction details.
*/
class BhTransDetail : public Gtk::VBox
{
public:
   BhTransDetail();
   BhTransDetail(bool bn, Glib::ustring basedir, NPCALLBACK np);
   BhTransDetail(bool bn, Glib::ustring basedir);
   explicit BhTransDetail(BaseObjectType* cobject);
//   explicit BhStatus(bhentry_type t = TYPE_TEXT);
   virtual ~BhTransDetail();
   void Clear();
   void SetText(BhTransDetailItem b, Glib::ustring buff);
   void SetColour(BhTransDetailItem, Gtk::StateType, Gdk::Color);
   sigc::signal<void, BhNumPadButton, int> signal_keypress(){ if(numpad) return numpad->signal_keypress(); }

protected:
   bool              bHasNumPad;
   class Gtk::Entry *number;
   class Gtk::Entry *subtotal;
   class Gtk::Entry *tax;
   class Gtk::Entry *total;
   class Gtk::Entry *tendered;
   class Gtk::Entry *change;
   class Gtk::Label *label1;
   class Gtk::Label *label2;
   class Gtk::Label *label3;
   class Gtk::Label *label4;
   class Gtk::Label *label5;
   class Gtk::Label *label6;
   class BhNumPad   *numpad;
};


/* @} 
	@} */

}

/* @} */

}

#endif // BHTRANSDETAIL_H
