/*
bhitemlist.cpp
Copyright (C) 2004 Al Kingsley

  This program is free software; you can redistribute it and/or modify
  it under the terms of the GNU General Public License as published by
  the Free Software Foundation; either version 2 of the License, or
  (at your option) any later version.
  
	This program is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU General Public License for more details.

	You should have received a copy of the GNU General Public License
	along with this program; if not, write to the Free Software
	Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

	Part of:
	BhPos, Copyright (C) 2001-2005 Al Kingsley
	BhPos comes with ABSOLUTELY NO WARRANTY. 
*/
#include "config.h"
#include "bhintl.h"
#include "bhtranslist.h"
#include <gtkmm/treemodel.h>
#include <gtkmm/image.h>
#include <gtkmm/stock.h>
#include <gtkmm/label.h>
#include <gtkmm/box.h>

namespace bhpos{
   
namespace widget{


TransColumns::TransColumns()
{ 
   add(status); 
   add(station); 
   add(description); 
   add(total);
   add(type);
   add(background);
   add(foreground);
}

BhTransactionList::BhTransactionList(Gtk::ScrolledWindow *sw) : Gtk::TreeView()
{  
   curr_column=0;
   Glib::ustring buff;
   set_name("bhtranslist");
   
   i_curr_row=0;
   row_height=0;
   num_rows=0;
   
   refls = Gtk::ListStore::create(columns);
   set_model(refls);
   refSelection = get_selection();
   
   Gtk::TreeViewColumn *col0_validated = new class Gtk::TreeViewColumn("Status");
   cell_col0 = Gtk::manage(new Gtk::CellRendererText());
   col0_validated->pack_start(*manage(cell_col0));
   col0_validated->add_attribute(cell_col0->property_text(), columns.status);
   col0_validated->add_attribute(cell_col0->property_background_gdk(), columns.background);
   col0_validated->add_attribute(cell_col0->property_foreground_gdk(), columns.foreground);
   cell_col0->property_background_set()=true;
   cell_col0->property_foreground_set()=true;
   //col0_validated->set_cell_data_func(*cell_col0, sigc::mem_fun(*this, &BhTransactionList::on_col0_validate));
   append_column(*manage(col0_validated));
   
   Gtk::TreeViewColumn *column = Gtk::manage(new class Gtk::TreeViewColumn("Station"));
   append_column(*column);
   cell_col1 = Gtk::manage(new Gtk::CellRendererText());
   column->pack_start(*manage(cell_col1));
   column->add_attribute(cell_col1->property_text(), columns.station);
   column->add_attribute(cell_col1->property_background_gdk(), columns.background);
   column->add_attribute(cell_col1->property_foreground_gdk(), columns.foreground);
   cell_col1->property_background_set()=true;
   cell_col1->property_foreground_set()=true;
   
   column = Gtk::manage(new class Gtk::TreeViewColumn("Description"));
   append_column(*column);
   cell_col2 = Gtk::manage(new Gtk::CellRendererText());
   column->pack_start(*manage(cell_col2));
   column->add_attribute(cell_col2->property_text(), columns.description);
   column->add_attribute(cell_col2->property_background_gdk(), columns.background);
   column->add_attribute(cell_col2->property_foreground_gdk(), columns.foreground);
   cell_col2->property_background_set()=true;
   cell_col2->property_foreground_set()=true;
   
   column = Gtk::manage(new class Gtk::TreeViewColumn("Total"));
   append_column(*column);
   cell_col3 = Gtk::manage(new Gtk::CellRendererText());
   column->pack_start(*manage(cell_col3));
   column->add_attribute(cell_col3->property_text(), columns.total);
   column->add_attribute(cell_col3->property_background_gdk(), columns.background);
   column->add_attribute(cell_col3->property_foreground_gdk(), columns.foreground);
   cell_col3->property_background_set()=true;
   cell_col3->property_foreground_set()=true;
      
   get_column(0)->set_sizing(Gtk::TREE_VIEW_COLUMN_FIXED);
   get_column(0)->set_fixed_width(120);
   get_column(1)->set_sizing(Gtk::TREE_VIEW_COLUMN_FIXED);
   get_column(1)->set_fixed_width(40);
   get_column(2)->set_sizing(Gtk::TREE_VIEW_COLUMN_FIXED);
   get_column(2)->set_fixed_width(380);
   get_column(3)->set_sizing(Gtk::TREE_VIEW_COLUMN_FIXED);
   get_column(3)->set_fixed_width(50);
   
   set_flags(Gtk::CAN_FOCUS);
   set_headers_visible(true);
   set_rules_hint(false);
   set_reorderable(false);
   set_enable_search(true);

   scroll_win=sw;
   row_height = (int) scroll_win->get_vadjustment()->get_upper();
}

BhTransactionList::~BhTransactionList()
{  
}

bool BhTransactionList::IsValidPath(Gtk::TreeModel::Path path)
{
   return false;
}
/*
int BhTransactionList::Update(CTransItems& transaction)
{
   CSaleItem si;
	CPayItem  pi;
   int       i;
   
   Clear();
   
   if(transaction.NumAllItems()==0) return 1;

   g_print("update: num items: %d\n", transaction.NumAllItems());
   
   for(i=0; i < transaction.NumAllItems(); i++){
		if(transaction.GetItem(i, si)){
         g_print("update::trans - item not found\n");
		}
		else{
     		//Append(&si);
  		}
	}
	return 0;
}

void BhTransactionList::SetRowColour(Gtk::TreeModel::iterator iter)
{
   Gdk::Color  fg, bg;
   
   if(!iter) return;
   Gtk::TreeModel::Row row=*iter;
   SetRowColour(row);
   //return;
}

void BhTransactionList::SetRowColour(Gtk::TreeModel::Row& row)
{
   Gdk::Color  fg, bg;
   
   if(!row) return;
   
   return;
   
   if(row[columns.status] == BHITEMLIST_STATUS_PAYFIXED){
      switch(row[columns.type]){
      case BHITEMLIST_TYPE_TOTAL:
         fg = colours->Get(BHCOL_ROW_TOTAL_FOREGROUND);
         bg = colours->Get(BHCOL_ROW_TOTAL_BACKGROUND);
         break;
         
      case BHITEMLIST_TYPE_TENDERTYPE_CASH:
         fg = colours->Get(BHCOL_ROW_TENDER_FOREGROUND);
         bg = colours->Get(BHCOL_ROW_TENDER_BACKGROUND);
         break;
      }
   }
   else if(row[columns.status] == BHITEMLIST_STATUS_FIXED){
      switch(row[columns.type]){
      case BHITEMLIST_TYPE_BLANK:
         break;
      case BHITEMLIST_TYPE_ITEM:
         fg=colours->Get(BHCOL_ROW_ITEM_FOREGROUND);
         bg=colours->Get(BHCOL_ROW_ITEM_BACKGROUND);
         break;
      
      case BHITEMLIST_TYPE_UNKNOWN:
         fg=colours->Get(BHCOL_ROW_UNKNOWN_FOREGROUND);
         bg=colours->Get(BHCOL_ROW_UNKNOWN_BACKGROUND);
         break;
      
      case BHITEMLIST_TYPE_LOOKUP:
         fg=colours->Get(BHCOL_ROW_LOOKUP_FOREGROUND);
         bg=colours->Get(BHCOL_ROW_LOOKUP_BACKGROUND);
         break;

      case BHITEMLIST_TYPE_PRICE:
         fg=colours->Get(BHCOL_ROW_PRICE_FOREGROUND);
         bg=colours->Get(BHCOL_ROW_PRICE_BACKGROUND);
         break;
      
      case BHITEMLIST_TYPE_RETURN:
      case BHITEMLIST_TYPE_LAYBY:
      case BHITEMLIST_TYPE_RENTAL:
      case BHITEMLIST_TYPE_EPHEMERAL:
         break;
      default:
         return;
      }
   }
   else if(row[columns.status] == BHITEMLIST_STATUS_DESCEDIT){
      fg=colours->Get(BHCOL_ROW_EDITUNKNOWN_FOREGROUND);
      bg=colours->Get(BHCOL_ROW_EDITUNKNOWN_BACKGROUND);
   }
   else if(row[columns.status] == BHITEMLIST_STATUS_PRICEEDIT){
      fg=colours->Get(BHCOL_ROW_EDITUNKNOWN_FOREGROUND);
      bg=colours->Get(BHCOL_ROW_EDITUNKNOWN_BACKGROUND);
   }
   else if(row[columns.status]==BHITEMLIST_STATUS_AMOUNTEDIT){
      fg=colours->Get(BHCOL_ROW_TENDER_FOREGROUND);
      bg=colours->Get(BHCOL_ROW_TENDER_BACKGROUND);
   }
   
   row[columns.foreground]=fg;
   row[columns.background]=bg;
   
   return;
}
*/
void BhTransactionList::Resize()
{
   double z;
   int    s, y, x, t=0;
   
   get_size_request(s, y);
   if(s < 1) return;
      
   z=100/s;
   x=(int) z*9;
   t+=x;
   get_column(1)->set_fixed_width(x);
   x=(int) z*11;
   t+=x;
   get_column(3)->set_fixed_width(x);
   get_column(4)->set_fixed_width(x);
   z=s/100;
   z=110/z;
   x=t-(int) z;
   get_column(2)->set_fixed_width(t);
}

void BhTransactionList::Clear()
{
   refls->clear();
   refSelection->unselect_all();
   num_rows=0;
   /*
   if(!refls){
      refls = Gtk::TreeStore::create(columns);
      set_model(refls);
   }*/
   //queue_draw();
}
/*
int BhTransactionList::TransList(BhSSTransList *tl, bool bShow)
{
   char                 cbuff[64];
   Glib::ustring        buff;
   Gtk::TreeModel::Row  row;
   BhSSTransListItem     *item=tl->items;
   
   refls->clear();
   
   if(bShow){
      get_column(0)->set_title(_("Started"));   
      get_column(1)->set_title(_("Items"));
      get_column(2)->set_title(_("Name"));
      get_column(3)->set_title(_("Total"));
      get_column(4)->set_title(_("Status"));
      
      for(int i=0; i < tl->num_items; i++){
         sprintf(cbuff, "%012d", item->timestamp);
         buff=cbuff;
         row[columns.plu]=buff;
         
         sprintf(cbuff, "%d", item->num_items);
         buff=cbuff;
         row[columns.quantity]=buff;
         
         sprintf(cbuff, "%0.2f", item->total);
         buff=cbuff;
         row[columns.subtotal]=buff;
         
         row[columns.type]=item->id;
         
         row[columns.description]=item->name;
         
         switch(item->status){
         case BHTRANS_STATUS_OPEN:    buff="Ready"; break;
         case BHTRANS_STATUS_TENDER:  buff="Tender"; break;
         case BHTRANS_STATUS_PAYAUTH: buff="Payment"; break;
         }
         row[columns.total]=buff;
         
         item++;
      }
   }
   else{
   }
   
   return 0;
}

int BhTransactionList::TransList(BhTransList *tl, bool bShow)
{
   char                 cbuff[64];
   Glib::ustring        buff;
   Gtk::TreeModel::Row  row;
   BhTransListItem     *item=tl->items;
   
   refls->clear();
   
   if(bShow){
      get_column(0)->set_title(_("Started"));   
      get_column(1)->set_title(_("Items"));
      get_column(2)->set_title(_("Name"));
      get_column(3)->set_title(_("Total"));
      get_column(4)->set_title(_("Status"));
      
      for(int i=0; i < tl->num_items; i++){
         sprintf(cbuff, "%012d", item->timestamp);
         buff=cbuff;
         row[columns.plu]=buff;
         
         sprintf(cbuff, "%d", item->num_items);
         buff=cbuff;
         row[columns.quantity]=buff;
         
         sprintf(cbuff, "%0.2f", item->total);
         buff=cbuff;
         row[columns.subtotal]=buff;
         
         row[columns.type]=item->id;
         
         row[columns.description]="Sale";
         
         switch(item->status){
         case BHTRANS_STATUS_OPEN:    buff="Ready"; break;
         case BHTRANS_STATUS_TENDER:  buff="Tender"; break;
         case BHTRANS_STATUS_PAYAUTH: buff="Payment"; break;
         }
         row[columns.total]=buff;
         
         item++;
      }
   }
   else{
   }
   
   return 0;
}
*/
/*
int BhTransactionList::Add(CPayItem& payitem)
{
   return 0;
}

int BhTransactionList::Remove(int row)
{
   return 0;
}
*/
bool BhTransactionList::Navigation(BhNavigationType n)
{
   refSelection=get_selection();
   Gtk::TreeModel::iterator iter = refSelection->get_selected();
   Gtk::TreeModel::Children children = refls->children();
   bool bPreviter=false;
   //Gtk::TreeModel::Path     path = refls->get_path(iter);
   
   if(!refls){
      // bum ref ptr
      g_print("bum refptr for treestore\n");
   }
   
   if(!refSelection){
      // bum ref ptr
      g_print("bum refptr for selected\n");
   }

   if(!iter){
      if(children.empty()) return true;
      iter=children.end();
      iter--;
      bPreviter=true;
      if(!iter){
         g_print("No Iterator\n");
         return true;
      }
   }
   Gtk::TreeModel::Row  row=*iter;
   Gtk::TreeModel::Path path(row);

   switch(n){
   case BHNAV_TYPE_UP:
      if(bPreviter){
         refSelection->select(path);              // select the row
	   	scroll_to_row(path);           // scroll to make visible
		   i_curr_row = *(path.get_indices().begin());    // remember where we are
         curr_row=iter;
   		scroll(true);
      }
      else{
         if(iter != children.begin()){  //doesn't work 
            iter--;
         //if(path.to_string()!="0"){
            //set_cell_foreground_color(iter, DEFAULT);
	   	   path.prev();			                    // go to the prev row
            refSelection->select(path);              // select the row
   	   	scroll_to_row(path);           // scroll to make visible
	   	   i_curr_row = *(path.get_indices().begin());    // remember where we are
            curr_row=iter;
   		   scroll(true);
		      //set_cell_foreground_color(iter, SELECTED);
         }
	   }
      break;
   
   case BHNAV_TYPE_DOWN:
      if(!is_last_row(iter)){ // Are we about to hit the end?
   		//set_cell_foreground_color (iter, DEFAULT);  // restore color of cell
	   	path.next();
		   refSelection->select(path);
   		scroll_to_row(path);           // scroll to make visible
	   	i_curr_row = *(path.get_indices().begin());    // remember where we are
		   scroll(false);
         iter++;
         curr_row=iter;
	   	//set_cell_foreground_color(iter, SELECTED);
	   }
      else{
         iter=children.end();
         iter--;
         curr_row=iter;
         scroll(false);
         refSelection->unselect_all();
      }
      break;
      
   case BHNAV_TYPE_PGUP:
   case BHNAV_TYPE_PGDOWN:
      break;
   
   case BHNAV_TYPE_HOME:
   {
      iter=children.begin();
      Gtk::TreeModel::Row  hrow=*iter;
      Gtk::TreeModel::Path hpath(hrow);
      curr_row=iter;
      refSelection->select(hpath);
      scroll_to_row(hpath);           // scroll to make visible
	   i_curr_row = *(hpath.get_indices().begin());    // remember where we are
		scroll(false);
   }
      break;
   
   case BHNAV_TYPE_END:
      iter=children.end();
      iter--;
      curr_row=iter;
      scroll(false);
      refSelection->unselect_all();
      break;
   /*
   case BHNAV_TYPE_LEFT:
      if (m_cursor == RIGHT_CELL) {
		   set_cell_foreground_color (iter, DEFAULT);
		   m_cursor = LEFT_CELL;
		   set_cell_foreground_color (iter, SELECTED);
	   }
      break;
      
   case BHNAV_TYPE_RIGHT:
      if (m_cursor == RIGHT_CELL) {
		   set_cell_foreground_color (iter, DEFAULT);
		   m_cursor = LEFT_CELL;
		   set_cell_foreground_color (iter, SELECTED);
	   }
      break;
      */
   }
   return false;
}

bool BhTransactionList::is_last_row(Gtk::TreeModel::iterator& iter_)
{
	Gtk::TreeModel::iterator iter_next = iter_;
	Gtk::TreeModel::Children children = refls->children();
	iter_next++;
	return (iter_next == children.end());
}

void BhTransactionList::scroll(bool bUp)
{
   double foo;
   double pg_inc = scroll_win->get_vadjustment()->get_page_increment();
   double value = scroll_win->get_vadjustment()->get_value(); 
   double pg_sz = scroll_win->get_vadjustment()->get_page_size();

	if(bUp){
   	if(((i_curr_row+1) * row_height - value) < row_height){
	   	scroll_win->get_vadjustment()->set_value(value - pg_inc/2);
	   }
   }
   else{
	   double last_page = scroll_win->get_vadjustment()->get_upper() - pg_sz;
		
   	if(((i_curr_row+1) * row_height - value) > pg_sz){
	   	if((foo = value + pg_inc/2) > last_page) {
		   	scroll_win->get_vadjustment()->set_value(last_page);
		   }
		   else{
		   	scroll_win->get_vadjustment()->set_value(foo);
		   }
	   }
   }
}

}

}
